using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using ReaderA;
using System.Resources;
using System.Reflection;
using System.IO.Ports;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Threading;
namespace HFReader09Demo
{
    public partial class frmHFReader09Demo : Form
    {
        private int portIndex = -1;
        private byte readerAddr = 0xff;
        private bool fIsTestMode = false;          //Ƿڽвģʽ
        private byte UserDefineBlockSize = 0; 
        private bool fIsScanMode = false;          //Ƿڽɨģʽ
        private ArrayList AlreadyOpenPortList = new ArrayList();
        private string DSFIDAndUIDList;           //洢ӿʼѯ鵽յ0E֮DSFID,UID 
        private byte totalCardNumber = 0;
        private const byte OK = 0x00;
        private bool fIsAppClose = false;
        private const byte lengthError = 0x01;
        private const byte operationNotSupport = 0x02;
        private const byte dataRangError = 0x03;
        private const byte cmdNotOperation = 0x04;
        private const byte rfClosed = 0x05;
        private const byte EEPROM = 0x06;
        private const byte timeOut = 0x0a;
        private const byte moreUID = 0x0b;
        private const byte ISOError = 0x0c;
        private const byte noElectronicTag = 0x0e;
        private const byte operationError = 0x0f;
        private const byte cmdNotSupport = 0x01;
        private const byte cmdNotIdentify = 0x02;
        private const byte errOperationNotSupport = 0x03;
        private const byte unknownError = 0x0f;
        private const byte blockError = 0x10;
        private const byte blockLockedCntLock = 0x11;
        private const byte blockLockedCntWrite = 0x12;
        private const byte blockCntOperate = 0x13;
        private const byte blockCntLock = 0x14;
        private const byte communicationErr = 0x30;
        private const byte retCRCErr = 0x31;
        private const byte retDataErr = 0x32;
        private const byte communicationBusy = 0x33;
        private const byte executeCmdBusy = 0x34;
        private const byte comPortOpened = 0x35;
        private const byte comPortClose = 0x36;
        private const byte invalidHandle = 0x37;
        private const byte invalidPort = 0x38;
        private byte Get_ParseMode=0x00;
        private int fCmdRet = 0x30;
        private int fOpenComIndex = -1;
        public frmHFReader09Demo()
        {
            InitializeComponent();
            InitializeComboBox();
            DSFIDAndUIDList = "";
            timerTestMode.Enabled = false;
            this.SetStyle(ControlStyles.DoubleBuffer |
                          ControlStyles.AllPaintingInWmPaint |
                          ControlStyles.UserPaint, true);
            UpdateStyles();
            InitializeBtnEnable();
        }

        private void InitializeComboBox()
        {
            cbComPortList.SelectedIndex = 0;
            cbRelayControl.SelectedIndex = 0;
            cbOutput1Status.SelectedIndex = 0;
            cbOutput2Status.SelectedIndex = 0;
            cbScanModeStartBlock.SelectedIndex = 1;
            cbScanModeBlockCount.SelectedIndex = 1;
            cbScanModeStartByte.SelectedIndex = 1;
            cbScanModeByteCount.SelectedIndex = 1;
            cbScanModeEndMark.SelectedIndex = 0;
            cbScanModeSpaceMark.SelectedIndex = 0;
            cbInventoryScanTimeToWrite.SelectedIndex = 27;
            cbAccessTimeToSet.SelectedIndex = 0;
            cbUserBlockSizeSet.SelectedIndex = 0;
            cbUserWriteType.SelectedIndex = 1;
            cbUserMaxBlockNum.SelectedIndex = 1;
            comboBox_baud2.SelectedIndex = 3;
            radioButton5.Checked = true;

        }

        private void InitializeBtnEnable()
        {
            //Զҳ
            gbpRelay.Enabled = false;
            gbpOutput.Enabled = false;
            gbpInput.Enabled = false;
            gbpGetANT.Enabled = false;
            gbpSetANT.Enabled = false;
            gbpParseMode.Enabled = false;
            gbpModulation.Enabled = false;
            gbpGetReceiveChannel.Enabled = false;
            gpbReaderInfo.Enabled = false;
            gbpSetReceiveChannel.Enabled = false;
            gbpWriteInventoryTime.Enabled = false;
            gbpTagAccessTime.Enabled = false;
            gbpWriteReaderAddress.Enabled = false;

            gbpsetbaud.Enabled = false;
            gbpebpsetting.Enabled = false;
            groupBox9.Enabled = false;
            gbpacc.Enabled = false;
            //ǩҳ
            gbpBlockOperation.Enabled = false;
            gbpDSFID.Enabled = false;
            gbpAFI.Enabled = false;
            gbpOtherCmd.Enabled = false;
            gbpRFSwitch.Enabled = false;
            gbpInventorySingle.Enabled = false;
            gbpInventoryMulti.Enabled = false;
            btnGetSystemInfo.Enabled = false;
            //ģʽҳ
            btnStartTestMode.Enabled = false;
            btnStopTestMode.Enabled = false;
            //ɨģʽҳ
            btnStartScanMode.Enabled = false;
            btnStopScanMode.Enabled = false;
            btnDisplayOn.Enabled = false;
            btnDisplayOff.Enabled = false;
            gbpScanModeSetting.Enabled = false;
            //Զݿ鳤
            gbpInventory.Enabled = false;
            gbpUserBlockLength.Enabled = false;
            gbpUserBlockOperation.Enabled = false;
            //͸
            gbpSpecifyRsptimeTransparentCmd.Enabled = false;
            gbpTransparentRead.Enabled = false;
            gbpTransparentWrite.Enabled = false;
            groupBox16.Enabled = false;

            button3.Enabled = false;
            button2.Enabled = false;
        }

        private void HF037SREnable()
        {
            //gbpRelay.Enabled = true;
            gbpOutput.Enabled = true;
            //gbpInput.Enabled = true;
            //gbpGetANT.Enabled = true;
            //gbpSetANT.Enabled = true;
            //gbpParseMode.Enabled = true;
            //gbpModulation.Enabled = true;
            //gbpGetReceiveChannel.Enabled = true;
            gpbReaderInfo.Enabled = true;
            //gbpSetReceiveChannel.Enabled = true;
            gbpWriteInventoryTime.Enabled = true;
            //gbpTagAccessTime.Enabled = true;
            gbpWriteReaderAddress.Enabled = true;
            //ǩҳ
            gbpBlockOperation.Enabled = true;
            //gbpDSFID.Enabled = true;
            //gbpAFI.Enabled = true;
            //gbpOtherCmd.Enabled = true;
            gbpRFSwitch.Enabled = true;
            gbpInventorySingle.Enabled = true;
            //gbpInventoryMulti.Enabled = true;
            //btnGetSystemInfo.Enabled = true;
            //ģʽҳ
            btnStartTestMode.Enabled = true;
            btnStopTestMode.Enabled = true;
            //ɨģʽҳ
            btnStartScanMode.Enabled = true;
            btnStopScanMode.Enabled = true;
            btnDisplayOn.Enabled = true;
            btnDisplayOff.Enabled = true;
            gbpScanModeSetting.Enabled = true;
            //Զݿ鳤
            gbpInventory.Enabled = true;
            gbpUserBlockLength.Enabled = true;
            gbpUserBlockOperation.Enabled = true;
            //͸
            if (string.Compare(tbReaderInfoVersion.Text, "06.00") > 0)
            {
                gbpSpecifyRsptimeTransparentCmd.Enabled = true;
                gbpTransparentRead.Enabled = true;
                gbpTransparentWrite.Enabled = true;
            }
            else
            if (tabControl1.TabPages.IndexOf(tpTransparent) >= 0)
                tabControl1.TabPages.Remove(tpTransparent);

            if (tabControl1.TabPages.IndexOf(tpTestMode) >= 0)
                tabControl1.TabPages.Remove(tpTestMode);
        }

        private void HF036SREnable()
        {
            //gbpRelay.Enabled = true;
            gbpOutput.Enabled = true;
            //gbpInput.Enabled = true;
            //gbpGetANT.Enabled = true;
            //gbpSetANT.Enabled = true;
            //gbpParseMode.Enabled = true;
            //gbpModulation.Enabled = true;
            //gbpGetReceiveChannel.Enabled = true;
            gpbReaderInfo.Enabled = true;
            //gbpSetReceiveChannel.Enabled = true;
            gbpWriteInventoryTime.Enabled = true;
            //gbpTagAccessTime.Enabled = true;
            gbpWriteReaderAddress.Enabled = true;
            //ǩҳ
            gbpBlockOperation.Enabled = true;
            //gbpDSFID.Enabled = true;
            //gbpAFI.Enabled = true;
            //gbpOtherCmd.Enabled = true;
            gbpRFSwitch.Enabled = true;
            gbpInventorySingle.Enabled = true;
            //gbpInventoryMulti.Enabled = true;
            //btnGetSystemInfo.Enabled = true;
            //ģʽҳ
            btnStartTestMode.Enabled = true;
            btnStopTestMode.Enabled = true;
            //ɨģʽҳ
            //btnStartScanMode.Enabled = true;
            //btnStopScanMode.Enabled = true;
            //btnDisplayOn.Enabled = true;
            //btnDisplayOff.Enabled = true;
            //gbpScanModeSetting.Enabled = true;
            //Զݿ鳤
            //gbpInventory.Enabled = true;
            gbpUserBlockLength.Enabled = true;
            //gbpUserBlockOperation.Enabled = true;
            //gbpRFSwitch2.Enabled = true;
            //͸
            //gbpSpecifyRsptimeTransparentCmd.Enabled = true;
            //gbpTransparentRead.Enabled = true;
            //gbpTransparentWrite.Enabled = true;

            if (tabControl1.TabPages.IndexOf(tpCoustomDataLen) >= 0)
                tabControl1.TabPages.Remove(tpCoustomDataLen);
            if (tabControl1.TabPages.IndexOf(tpTransparent) >= 0)
                tabControl1.TabPages.Remove(tpTransparent);
            if (tabControl1.TabPages.IndexOf(tpTestMode) >= 0)
                tabControl1.TabPages.Remove(tpTestMode);
            if (tabControl1.TabPages.IndexOf(tpScanMode) >= 0)
                tabControl1.TabPages.Remove(tpScanMode);
        }

        private void HF296AEnable()
        {
            //gbpRelay.Enabled = true;
            //gbpOutput.Enabled = true;
            //gbpInput.Enabled = true;
            //gbpGetANT.Enabled = true;
            //gbpSetANT.Enabled = true;
            //gbpParseMode.Enabled = true;
            //gbpModulation.Enabled = true;
            gbpsetbaud.Enabled = true;
            gbpebpsetting.Enabled = true;
            gbpGetReceiveChannel.Enabled = true;
            gpbReaderInfo.Enabled = true;
            gbpSetReceiveChannel.Enabled = true;
            gbpWriteInventoryTime.Enabled = true;
            //gbpTagAccessTime.Enabled = true;
            gbpWriteReaderAddress.Enabled = true;
            //ǩҳ
            gbpBlockOperation.Enabled = true;
            //gbpDSFID.Enabled = true;
            //gbpAFI.Enabled = true;
            //gbpOtherCmd.Enabled = true;
            gbpRFSwitch.Enabled = true;
            gbpInventorySingle.Enabled = true;
            gbpInventoryMulti.Enabled = true;
            //btnGetSystemInfo.Enabled = true;
            //ģʽҳ
            btnStartTestMode.Enabled = true;
            btnStopTestMode.Enabled = true;
            //ɨģʽҳ
            btnStartScanMode.Enabled = true;
            btnStopScanMode.Enabled = true;
            btnDisplayOn.Enabled = true;
            btnDisplayOff.Enabled = true;
            gbpScanModeSetting.Enabled = true;
            //Զݿ鳤
            //gbpInventory.Enabled = true;
            gbpUserBlockLength.Enabled = true;
            //gbpUserBlockOperation.Enabled = true;
            //gbpRFSwitch2.Enabled = true;
            //͸

            btnGetReceiveChannelStatus_Click(null, null);
            if (tbReceiveChannelStatus.Text.IndexOf("TX/RX") >= 0)
            {
                gbpSpecifyRsptimeTransparentCmd.Enabled = true;
                gbpTransparentRead.Enabled = true;
                gbpTransparentWrite.Enabled = true;
            }
            else
            {
                if (tabControl1.TabPages.IndexOf(tpTransparent) >= 0)
                    tabControl1.TabPages.Remove(tpTransparent);
            }
        }

        private void HF293TEnanle()
        {
            gbpsetbaud.Enabled = true;
            gbpebpsetting.Enabled = true;
            gbpRelay.Enabled = true;
            gbpOutput.Enabled = true;
            gbpInput.Enabled = true;
            gbpGetANT.Enabled = true;
            gbpSetANT.Enabled = true;
            gbpParseMode.Enabled = true;
            gbpModulation.Enabled = true;
            //gbpGetReceiveChannel.Enabled = true;
            gpbReaderInfo.Enabled = true;
            //gbpSetReceiveChannel.Enabled = true;
            gbpWriteInventoryTime.Enabled = true;
            //gbpTagAccessTime.Enabled = true;
            gbpWriteReaderAddress.Enabled = true;
            //ǩҳ
            gbpBlockOperation.Enabled = true;
            //gbpDSFID.Enabled = true;
            //gbpAFI.Enabled = true;
            //gbpOtherCmd.Enabled = true;
            gbpRFSwitch.Enabled = true;
            gbpInventorySingle.Enabled = true;
            gbpInventoryMulti.Enabled = true;
            //btnGetSystemInfo.Enabled = true;
            //ģʽҳ
            btnStartTestMode.Enabled = true;
            btnStopTestMode.Enabled = true;
            //ɨģʽҳ
            btnStartScanMode.Enabled = true;
            btnStopScanMode.Enabled = true;
            btnDisplayOn.Enabled = true;
            btnDisplayOff.Enabled = true;
            gbpScanModeSetting.Enabled = true;
            //Զݿ鳤
            gbpInventory.Enabled = true;
            gbpUserBlockLength.Enabled = true;
            gbpUserBlockOperation.Enabled = true;

            //͸
            gbpSpecifyRsptimeTransparentCmd.Enabled = true;
            gbpTransparentRead.Enabled = true;
            gbpTransparentWrite.Enabled = true;   
        }

        private void HF292TEnanle()
        {
            gbpsetbaud.Enabled = true;
            gbpebpsetting.Enabled = true;
            gbpRelay.Enabled = true;
            gbpOutput.Enabled = true;
            gbpInput.Enabled = true;
            gbpGetANT.Enabled = true;
            gbpSetANT.Enabled = true;
            gbpParseMode.Enabled = true;
            gbpModulation.Enabled = true;
            //gbpGetReceiveChannel.Enabled = true;
            gpbReaderInfo.Enabled = true;
            //gbpSetReceiveChannel.Enabled = true;
            gbpWriteInventoryTime.Enabled = true;
            //gbpTagAccessTime.Enabled = true;
            gbpWriteReaderAddress.Enabled = true;
            //ǩҳ
            gbpBlockOperation.Enabled = true;
            //gbpDSFID.Enabled = true;
            //gbpAFI.Enabled = true;
            //gbpOtherCmd.Enabled = true;
            gbpRFSwitch.Enabled = true;
            gbpInventorySingle.Enabled = true;
            gbpInventoryMulti.Enabled = true;
            //btnGetSystemInfo.Enabled = true;
            //ģʽҳ
            btnStartTestMode.Enabled = true;
            btnStopTestMode.Enabled = true;
            //ɨģʽҳ
            btnStartScanMode.Enabled = true;
            btnStopScanMode.Enabled = true;
            btnDisplayOn.Enabled = true;
            btnDisplayOff.Enabled = true;
            gbpScanModeSetting.Enabled = true;
            //Զݿ鳤
            gbpInventory.Enabled = true;
            gbpUserBlockLength.Enabled = true;
            gbpUserBlockOperation.Enabled = true;

            //͸
            gbpSpecifyRsptimeTransparentCmd.Enabled = true;
            gbpTransparentRead.Enabled = true;
            gbpTransparentWrite.Enabled = true;
        }

        private void HF291TEnanle()
        {
            gbpsetbaud.Enabled = true;
            gbpebpsetting.Enabled = true;
            gbpRelay.Enabled = true;
            gbpOutput.Enabled = true;
            gbpInput.Enabled = true;
            //gbpGetANT.Enabled = true;
            //gbpSetANT.Enabled = true;
            gbpParseMode.Enabled = true;
            gbpModulation.Enabled = true;
            //gbpGetReceiveChannel.Enabled = true;
            gpbReaderInfo.Enabled = true;
            //gbpSetReceiveChannel.Enabled = true;
            gbpWriteInventoryTime.Enabled = true;
            //gbpTagAccessTime.Enabled = true;
            gbpWriteReaderAddress.Enabled = true;
            //ǩҳ
            gbpBlockOperation.Enabled = true;
            //gbpDSFID.Enabled = true;
            //gbpAFI.Enabled = true;
            //gbpOtherCmd.Enabled = true;
            gbpRFSwitch.Enabled = true;
            gbpInventorySingle.Enabled = true;
            gbpInventoryMulti.Enabled = true;
            //btnGetSystemInfo.Enabled = true;
            //ģʽҳ
            btnStartTestMode.Enabled = true;
            btnStopTestMode.Enabled = true;
            //ɨģʽҳ
            btnStartScanMode.Enabled = true;
            btnStopScanMode.Enabled = true;
            btnDisplayOn.Enabled = true;
            btnDisplayOff.Enabled = true;
            gbpScanModeSetting.Enabled = true;
            //Զݿ鳤
            gbpInventory.Enabled = true;
            gbpUserBlockLength.Enabled = true;
            gbpUserBlockOperation.Enabled = true;

            //͸
            gbpSpecifyRsptimeTransparentCmd.Enabled = true;
            gbpTransparentRead.Enabled = true;
            gbpTransparentWrite.Enabled = true;   
        }

        private void HF293AEnable()
        {
            gbpRelay.Enabled = true;
            gbpOutput.Enabled = true;
            gbpInput.Enabled = true;
            gbpGetANT.Enabled = true;
            gbpSetANT.Enabled = true;
            //gbpParseMode.Enabled = true;
            //gbpModulation.Enabled = true;
            //gbpGetReceiveChannel.Enabled = true;
            gpbReaderInfo.Enabled = true;
            //gbpSetReceiveChannel.Enabled = true;
            gbpWriteInventoryTime.Enabled = true;
            //gbpTagAccessTime.Enabled = true;
            gbpWriteReaderAddress.Enabled = true;
            //ǩҳ
            gbpBlockOperation.Enabled = true;
            //gbpDSFID.Enabled = true;
            //gbpAFI.Enabled = true;
            //gbpOtherCmd.Enabled = true;
            gbpRFSwitch.Enabled = true;
            gbpInventorySingle.Enabled = true;
            gbpInventoryMulti.Enabled = true;
            //btnGetSystemInfo.Enabled = true;
            //ģʽҳ
            btnStartTestMode.Enabled = true;
            btnStopTestMode.Enabled = true;
            //ɨģʽҳ
            btnStartScanMode.Enabled = true;
            btnStopScanMode.Enabled = true;
            btnDisplayOn.Enabled = true;
            btnDisplayOff.Enabled = true;
            gbpScanModeSetting.Enabled = true;
            //Զݿ鳤
            gbpInventory.Enabled = true;
            gbpUserBlockLength.Enabled = true;
            gbpUserBlockOperation.Enabled = true;

            //͸
            //gbpSpecifyRsptimeTransparentCmd.Enabled = true;
            //gbpTransparentRead.Enabled = true;
            //gbpTransparentWrite.Enabled = true;  

            if (tabControl1.TabPages.IndexOf(tpTransparent) >= 0)
                tabControl1.TabPages.Remove(tpTransparent);
        }

        private void HF292AEnable()
        {
            gbpRelay.Enabled = true;
            gbpOutput.Enabled = true;
            gbpInput.Enabled = true;
            gbpGetANT.Enabled = true;
            gbpSetANT.Enabled = true;
            //gbpParseMode.Enabled = true;
            //gbpModulation.Enabled = true;
            //gbpGetReceiveChannel.Enabled = true;
            gpbReaderInfo.Enabled = true;
            //gbpSetReceiveChannel.Enabled = true;
            gbpWriteInventoryTime.Enabled = true;
            //gbpTagAccessTime.Enabled = true;
            gbpWriteReaderAddress.Enabled = true;
            //ǩҳ
            gbpBlockOperation.Enabled = true;
            //gbpDSFID.Enabled = true;
            //gbpAFI.Enabled = true;
            //gbpOtherCmd.Enabled = true;
            gbpRFSwitch.Enabled = true;
            gbpInventorySingle.Enabled = true;
            gbpInventoryMulti.Enabled = true;
            //btnGetSystemInfo.Enabled = true;
            //ģʽҳ
            btnStartTestMode.Enabled = true;
            btnStopTestMode.Enabled = true;
            //ɨģʽҳ
            btnStartScanMode.Enabled = true;
            btnStopScanMode.Enabled = true;
            btnDisplayOn.Enabled = true;
            btnDisplayOff.Enabled = true;
            gbpScanModeSetting.Enabled = true;
            //Զݿ鳤
            gbpInventory.Enabled = true;
            gbpUserBlockLength.Enabled = true;
            gbpUserBlockOperation.Enabled = true;

            //͸
            //gbpSpecifyRsptimeTransparentCmd.Enabled = true;
            //gbpTransparentRead.Enabled = true;
            //gbpTransparentWrite.Enabled = true;

            if (tabControl1.TabPages.IndexOf(tpTransparent) >= 0)
                tabControl1.TabPages.Remove(tpTransparent);
        }

        private void HF291FEnable()
        {
            gbpRelay.Enabled = true;
            gbpOutput.Enabled = true;
            gbpInput.Enabled = true;
            //gbpGetANT.Enabled = true;
            //gbpSetANT.Enabled = true;
            //gbpParseMode.Enabled = true;
            //gbpModulation.Enabled = true;
            //gbpGetReceiveChannel.Enabled = true;
            gpbReaderInfo.Enabled = true;
            //gbpSetReceiveChannel.Enabled = true;
            gbpWriteInventoryTime.Enabled = true;
            gbpTagAccessTime.Enabled = true;
            gbpWriteReaderAddress.Enabled = true;
            //ǩҳ
            gbpBlockOperation.Enabled = true;
            //gbpDSFID.Enabled = true;
            //gbpAFI.Enabled = true;
            //gbpOtherCmd.Enabled = true;
            gbpRFSwitch.Enabled = true;
            gbpInventorySingle.Enabled = true;
            gbpInventoryMulti.Enabled = true;
            //btnGetSystemInfo.Enabled = true;
            //ģʽҳ
            btnStartTestMode.Enabled = true;
            btnStopTestMode.Enabled = true;
            //ɨģʽҳ
            btnStartScanMode.Enabled = true;
            btnStopScanMode.Enabled = true;
            btnDisplayOn.Enabled = true;
            btnDisplayOff.Enabled = true;
            gbpScanModeSetting.Enabled = true;
            //Զݿ鳤
            gbpInventory.Enabled = true;
            gbpUserBlockLength.Enabled = true;
            gbpUserBlockOperation.Enabled = true;

            //͸
            //gbpSpecifyRsptimeTransparentCmd.Enabled = true;
            //gbpTransparentRead.Enabled = true;
            //gbpTransparentWrite.Enabled = true;

            if (tabControl1.TabPages.IndexOf(tpTransparent) >= 0)
                tabControl1.TabPages.Remove(tpTransparent);

        }

        private void HF291Enable()
        {
            gbpRelay.Enabled = true;
            gbpOutput.Enabled = true;
            gbpInput.Enabled = true;
            //gbpGetANT.Enabled = true;
            //gbpSetANT.Enabled = true;
            //gbpParseMode.Enabled = true;
            //gbpModulation.Enabled = true;
            //gbpGetReceiveChannel.Enabled = true;
            gpbReaderInfo.Enabled = true;
            //gbpSetReceiveChannel.Enabled = true;
            gbpWriteInventoryTime.Enabled = true;
            //gbpTagAccessTime.Enabled = true;
            gbpWriteReaderAddress.Enabled = true;
            //ǩҳ
            gbpBlockOperation.Enabled = true;
            //gbpDSFID.Enabled = true;
            //gbpAFI.Enabled = true;
            //gbpOtherCmd.Enabled = true;
            gbpRFSwitch.Enabled = true;
            gbpInventorySingle.Enabled = true;
            gbpInventoryMulti.Enabled = true;
            //btnGetSystemInfo.Enabled = true;
            //ģʽҳ
            btnStartTestMode.Enabled = true;
            btnStopTestMode.Enabled = true;
            //ɨģʽҳ
            btnStartScanMode.Enabled = true;
            btnStopScanMode.Enabled = true;
            btnDisplayOn.Enabled = true;
            btnDisplayOff.Enabled = true;
            gbpScanModeSetting.Enabled = true;
            //Զݿ鳤
            gbpInventory.Enabled = true;
            gbpUserBlockLength.Enabled = true;
            gbpUserBlockOperation.Enabled = true;

            //͸
            if (string.Compare(tbReaderInfoVersion.Text, "06.00") > 0)
            {
                gbpSpecifyRsptimeTransparentCmd.Enabled = true;
                gbpTransparentRead.Enabled = true;
                gbpTransparentWrite.Enabled = true;
            }
            else
            if (tabControl1.TabPages.IndexOf(tpTransparent) >= 0)
                tabControl1.TabPages.Remove(tpTransparent);
        }

        private void HF203TEnable()
        {
            gbpsetbaud.Enabled = true;
            gbpebpsetting.Enabled = true;
            gbpRelay.Enabled = true;
            gbpOutput.Enabled = true;
            gbpInput.Enabled = true;
            gbpGetANT.Enabled = true;
            gbpSetANT.Enabled = true;
            gbpParseMode.Enabled = true;
            gbpModulation.Enabled = true;
            //gbpGetReceiveChannel.Enabled = true;
            gpbReaderInfo.Enabled = true;
            //gbpSetReceiveChannel.Enabled = true;
            gbpWriteInventoryTime.Enabled = true;
            //gbpTagAccessTime.Enabled = true;
            gbpWriteReaderAddress.Enabled = true;
            //ǩҳ
            gbpBlockOperation.Enabled = true;
            //gbpDSFID.Enabled = true;
            //gbpAFI.Enabled = true;
            //gbpOtherCmd.Enabled = true;
            gbpRFSwitch.Enabled = true;
            gbpInventorySingle.Enabled = true;
            gbpInventoryMulti.Enabled = true;
            //btnGetSystemInfo.Enabled = true;
            //ģʽҳ
            btnStartTestMode.Enabled = true;
            btnStopTestMode.Enabled = true;
            //ɨģʽҳ
            //btnStartScanMode.Enabled = true;
            //btnStopScanMode.Enabled = true;
            //btnDisplayOn.Enabled = true;
            //btnDisplayOff.Enabled = true;
            //gbpScanModeSetting.Enabled = true;
            //Զݿ鳤
            //gbpInventory.Enabled = true;
            //gbpUserBlockLength.Enabled = true;
            //gbpUserBlockOperation.Enabled = true;
            //gbpRFSwitch2.Enabled = true;
            //͸
            gbpSpecifyRsptimeTransparentCmd.Enabled = true;
            gbpTransparentRead.Enabled = true;
            gbpTransparentWrite.Enabled = true;

            if (tabControl1.TabPages.IndexOf(tpCoustomDataLen) >= 0)
                tabControl1.TabPages.Remove(tpCoustomDataLen);
            if (tabControl1.TabPages.IndexOf(tpScanMode) >= 0)
                tabControl1.TabPages.Remove(tpScanMode);
        }

        private void HF202TEnable()
        {
            gbpsetbaud.Enabled = true;
            gbpebpsetting.Enabled = true;
            gbpRelay.Enabled = true;
            gbpOutput.Enabled = true;
            gbpInput.Enabled = true;
            gbpGetANT.Enabled = true;
            gbpSetANT.Enabled = true;
            gbpParseMode.Enabled = true;
            gbpModulation.Enabled = true;
            //gbpGetReceiveChannel.Enabled = true;
            gpbReaderInfo.Enabled = true;
            //gbpSetReceiveChannel.Enabled = true;
            gbpWriteInventoryTime.Enabled = true;
            //gbpTagAccessTime.Enabled = true;
            gbpWriteReaderAddress.Enabled = true;
            //ǩҳ
            gbpBlockOperation.Enabled = true;
            //gbpDSFID.Enabled = true;
            //gbpAFI.Enabled = true;
            //gbpOtherCmd.Enabled = true;
            gbpRFSwitch.Enabled = true;
            gbpInventorySingle.Enabled = true;
            gbpInventoryMulti.Enabled = true;
            //btnGetSystemInfo.Enabled = true;
            //ģʽҳ
            btnStartTestMode.Enabled = true;
            btnStopTestMode.Enabled = true;
            //ɨģʽҳ
            //btnStartScanMode.Enabled = true;
            //btnStopScanMode.Enabled = true;
            //btnDisplayOn.Enabled = true;
            //btnDisplayOff.Enabled = true;
            //gbpScanModeSetting.Enabled = true;
            //Զݿ鳤
            //gbpInventory.Enabled = true;
            //gbpUserBlockLength.Enabled = true;
            //gbpUserBlockOperation.Enabled = true;
            //gbpRFSwitch2.Enabled = true;
            //͸
            gbpSpecifyRsptimeTransparentCmd.Enabled = true;
            gbpTransparentRead.Enabled = true;
            gbpTransparentWrite.Enabled = true;

            if (tabControl1.TabPages.IndexOf(tpCoustomDataLen) >= 0)
                tabControl1.TabPages.Remove(tpCoustomDataLen);
            if (tabControl1.TabPages.IndexOf(tpScanMode) >= 0)
                tabControl1.TabPages.Remove(tpScanMode);
        }

        private void HF201TEnable()
        {
            gbpsetbaud.Enabled = true;
            gbpebpsetting.Enabled = true;
            gbpRelay.Enabled = true;
            gbpOutput.Enabled = true;
            gbpInput.Enabled = true;
            //gbpGetANT.Enabled = true;
            //gbpSetANT.Enabled = true;
            gbpParseMode.Enabled = true;
            gbpModulation.Enabled = true;
            //gbpGetReceiveChannel.Enabled = true;
            gpbReaderInfo.Enabled = true;
            //gbpSetReceiveChannel.Enabled = true;
            gbpWriteInventoryTime.Enabled = true;
            //gbpTagAccessTime.Enabled = true;
            gbpWriteReaderAddress.Enabled = true;
            //ǩҳ
            gbpBlockOperation.Enabled = true;
            //gbpDSFID.Enabled = true;
            //gbpAFI.Enabled = true;
            //gbpOtherCmd.Enabled = true;
            gbpRFSwitch.Enabled = true;
            gbpInventorySingle.Enabled = true;
            gbpInventoryMulti.Enabled = true;
            //btnGetSystemInfo.Enabled = true;
            //ģʽҳ
            btnStartTestMode.Enabled = true;
            btnStopTestMode.Enabled = true;
            //ɨģʽҳ
            //btnStartScanMode.Enabled = true;
            //btnStopScanMode.Enabled = true;
            //btnDisplayOn.Enabled = true;
            //btnDisplayOff.Enabled = true;
            //gbpScanModeSetting.Enabled = true;
            //Զݿ鳤
            //gbpInventory.Enabled = true;
            //gbpUserBlockLength.Enabled = true;
            //gbpUserBlockOperation.Enabled = true;
            //gbpRFSwitch2.Enabled = true;
            //͸
            gbpSpecifyRsptimeTransparentCmd.Enabled = true;
            gbpTransparentRead.Enabled = true;
            gbpTransparentWrite.Enabled = true;

            if (tabControl1.TabPages.IndexOf(tpCoustomDataLen) >= 0)
                tabControl1.TabPages.Remove(tpCoustomDataLen);
            if (tabControl1.TabPages.IndexOf(tpScanMode) >= 0)
                tabControl1.TabPages.Remove(tpScanMode);
        }

        private void HF203AEnable()
        {
            gbpRelay.Enabled = true;
            gbpOutput.Enabled = true;
            gbpInput.Enabled = true;
            gbpGetANT.Enabled = true;
            gbpSetANT.Enabled = true;
            //gbpParseMode.Enabled = true;
            //gbpModulation.Enabled = true;
            //gbpGetReceiveChannel.Enabled = true;
            gpbReaderInfo.Enabled = true;
            //gbpSetReceiveChannel.Enabled = true;
            gbpWriteInventoryTime.Enabled = true;
            //gbpTagAccessTime.Enabled = true;
            gbpWriteReaderAddress.Enabled = true;
            //ǩҳ
            gbpBlockOperation.Enabled = true;
            gbpDSFID.Enabled = true;
            gbpAFI.Enabled = true;
            gbpOtherCmd.Enabled = true;
            gbpRFSwitch.Enabled = true;
            gbpInventorySingle.Enabled = true;
            gbpInventoryMulti.Enabled = true;
            //btnGetSystemInfo.Enabled = true;
            //ģʽҳ
            btnStartTestMode.Enabled = true;
            btnStopTestMode.Enabled = true;
            //ɨģʽҳ
            //btnStartScanMode.Enabled = true;
            //btnStopScanMode.Enabled = true;
            //btnDisplayOn.Enabled = true;
            //btnDisplayOff.Enabled = true;
            //gbpScanModeSetting.Enabled = true;
            //Զݿ鳤
            //gbpInventory.Enabled = true;
            //gbpUserBlockLength.Enabled = true;
            //gbpUserBlockOperation.Enabled = true;
            //gbpRFSwitch2.Enabled = true;
            //͸
            //gbpSpecifyRsptimeTransparentCmd.Enabled = true;
            //gbpTransparentRead.Enabled = true;
            //gbpTransparentWrite.Enabled = true;

            if (tabControl1.TabPages.IndexOf(tpTransparent) >= 0)
                tabControl1.TabPages.Remove(tpTransparent);
            if (tabControl1.TabPages.IndexOf(tpCoustomDataLen) >= 0)
                tabControl1.TabPages.Remove(tpCoustomDataLen);
            if (tabControl1.TabPages.IndexOf(tpScanMode) >= 0)
                tabControl1.TabPages.Remove(tpScanMode);
        }

        private void HF202AEnable()
        {
            gbpRelay.Enabled = true;
            gbpOutput.Enabled = true;
            gbpInput.Enabled = true;
            gbpGetANT.Enabled = true;
            gbpSetANT.Enabled = true;
            //gbpParseMode.Enabled = true;
            //gbpModulation.Enabled = true;
            //gbpGetReceiveChannel.Enabled = true;
            gpbReaderInfo.Enabled = true;
            //gbpSetReceiveChannel.Enabled = true;
            gbpWriteInventoryTime.Enabled = true;
            //gbpTagAccessTime.Enabled = true;
            gbpWriteReaderAddress.Enabled = true;
            //ǩҳ
            gbpBlockOperation.Enabled = true;
            //gbpDSFID.Enabled = true;
            //gbpAFI.Enabled = true;
            //gbpOtherCmd.Enabled = true;
            gbpRFSwitch.Enabled = true;
            gbpInventorySingle.Enabled = true;
            gbpInventoryMulti.Enabled = true;
            //btnGetSystemInfo.Enabled = true;
            //ģʽҳ
            btnStartTestMode.Enabled = true;
            btnStopTestMode.Enabled = true;
            //ɨģʽҳ
            //btnStartScanMode.Enabled = true;
            //btnStopScanMode.Enabled = true;
            //btnDisplayOn.Enabled = true;
            //btnDisplayOff.Enabled = true;
            //gbpScanModeSetting.Enabled = true;
            //Զݿ鳤
            //gbpInventory.Enabled = true;
            //gbpUserBlockLength.Enabled = true;
            //gbpUserBlockOperation.Enabled = true;
            //gbpRFSwitch2.Enabled = true;
            //͸
            //gbpSpecifyRsptimeTransparentCmd.Enabled = true;
            //gbpTransparentRead.Enabled = true;
            //gbpTransparentWrite.Enabled = true;

            if (tabControl1.TabPages.IndexOf(tpTransparent) >= 0)
                tabControl1.TabPages.Remove(tpTransparent);
            if (tabControl1.TabPages.IndexOf(tpCoustomDataLen) >= 0)
                tabControl1.TabPages.Remove(tpCoustomDataLen);
            if (tabControl1.TabPages.IndexOf(tpScanMode) >= 0)
                tabControl1.TabPages.Remove(tpScanMode);
        }

        private void HF201LiteEnable()
        {
            //gbpRelay.Enabled = true;
            //gbpOutput.Enabled = true;
            //gbpInput.Enabled = true;
            //gbpGetANT.Enabled = true;
            //gbpSetANT.Enabled = true;
            //gbpParseMode.Enabled = true;
            //gbpModulation.Enabled = true;
            //gbpGetReceiveChannel.Enabled = true;
            gpbReaderInfo.Enabled = true;
            //gbpSetReceiveChannel.Enabled = true;
            //gbpWriteInventoryTime.Enabled = true;
            //gbpTagAccessTime.Enabled = true;
            gbpWriteReaderAddress.Enabled = true;
            //ǩҳ
            //gbpBlockOperation.Enabled = true;
            //gbpDSFID.Enabled = true;
            //gbpAFI.Enabled = true;
            //gbpOtherCmd.Enabled = true;
            btnResetToReady.Enabled = false;
            btnStayQuite.Enabled = true;
            btnSelect.Enabled = false;
            gbpRFSwitch.Enabled = true;
            gbpInventorySingle.Enabled = true;
            gbpInventoryMulti.Enabled = true;
            //btnGetSystemInfo.Enabled = true;
            //ģʽҳ
            btnStartTestMode.Enabled = true;
            btnStopTestMode.Enabled = true;
            //ɨģʽҳ
            //btnStartScanMode.Enabled = true;
            //btnStopScanMode.Enabled = true;
            //btnDisplayOn.Enabled = true;
            //btnDisplayOff.Enabled = true;
            //gbpScanModeSetting.Enabled = true;
            //Զݿ鳤
            //gbpInventory.Enabled = true;
            //gbpUserBlockLength.Enabled = true;
            //gbpUserBlockOperation.Enabled = true;
            //gbpRFSwitch2.Enabled = true;
            //͸
            //gbpSpecifyRsptimeTransparentCmd.Enabled = true;
            //gbpTransparentRead.Enabled = true;
            //gbpTransparentWrite.Enabled = true;

            if (tabControl1.TabPages.IndexOf(tpTransparent) >= 0)
                tabControl1.TabPages.Remove(tpTransparent);
            if (tabControl1.TabPages.IndexOf(tpCoustomDataLen) >= 0)
                tabControl1.TabPages.Remove(tpCoustomDataLen);
            if (tabControl1.TabPages.IndexOf(tpScanMode) >= 0)
                tabControl1.TabPages.Remove(tpScanMode);
        }

        private void HF201Enable()
        {
            gbpRelay.Enabled = true;
            gbpOutput.Enabled = true;
            gbpInput.Enabled = true;
            //gbpGetANT.Enabled = true;
            //gbpSetANT.Enabled = true;
            //gbpParseMode.Enabled = true;
            //gbpModulation.Enabled = true;
            //gbpGetReceiveChannel.Enabled = true;
            gpbReaderInfo.Enabled = true;
            //gbpSetReceiveChannel.Enabled = true;
            gbpWriteInventoryTime.Enabled = true;
            //gbpTagAccessTime.Enabled = true;
            gbpWriteReaderAddress.Enabled = true;
            //ǩҳ
            gbpBlockOperation.Enabled = true;
            //gbpDSFID.Enabled = true;
            //gbpAFI.Enabled = true;
            //gbpOtherCmd.Enabled = true;
            gbpRFSwitch.Enabled = true;
            gbpInventorySingle.Enabled = true;
            gbpInventoryMulti.Enabled = true;

            //btnGetSystemInfo.Enabled = true;
            //ģʽҳ
            btnStartTestMode.Enabled = true;
            btnStopTestMode.Enabled = true;
            //ɨģʽҳ
            //btnStartScanMode.Enabled = true;
            //btnStopScanMode.Enabled = true;
            //btnDisplayOn.Enabled = true;
            //btnDisplayOff.Enabled = true;
            //gbpScanModeSetting.Enabled = true;
            //Զݿ鳤
            //gbpInventory.Enabled = true;
            //gbpUserBlockLength.Enabled = true;
            //gbpUserBlockOperation.Enabled = true;
            //gbpRFSwitch2.Enabled = true;
            //͸
            if (string.Compare(tbReaderInfoVersion.Text, "06.00") > 0)
            {
                gbpSpecifyRsptimeTransparentCmd.Enabled = true;
                gbpTransparentRead.Enabled = true;
                gbpTransparentWrite.Enabled = true;
            }
            else
            if (tabControl1.TabPages.IndexOf(tpTransparent) >= 0)
                tabControl1.TabPages.Remove(tpTransparent);

            if (tabControl1.TabPages.IndexOf(tpCoustomDataLen) >= 0)
                tabControl1.TabPages.Remove(tpCoustomDataLen);

            if (tabControl1.TabPages.IndexOf(tpScanMode) >= 0)
                tabControl1.TabPages.Remove(tpScanMode);
        }      
       
        private string HF000GetReturnCodeDesc(int cmdRet)
        {
            switch (cmdRet)
            {
                case lengthError:
                    return "ȴ";
                case operationNotSupport:
                    return "֧";
                case dataRangError:
                    return "Χ";
                case rfClosed:
                    return "Ӧڹر״̬";
                case EEPROM:
                    return "EEPROM";
                case timeOut:
                    return "ָInventory-Scan-Time";
                case moreUID:
                    return "Inventory-Scan-Timeʱ޵õеӱǩUID";
                case ISOError:
                    return "ISO ";
                case noElectronicTag:
                    return "޵ӱǩɲ";
                case operationError:
                    return "";
                case communicationErr:
                    return "";
                case retCRCErr:
                    return "CRCУ";
                case communicationBusy:
                    return "ͨѶæ豸ִָ";
                case cmdNotOperation:
                    return "ǰ޷ִ";
                case comPortOpened:
                    return "˿Ѵ";
                case comPortClose:
                    return "˿ѹر";
                case invalidHandle:
                    return "Чľ";
                case invalidPort:
                    return "ЧĶ˿ ";
                case OK:
                    return "ɹ";
                default:
                    return "";
            }
        }

        private string HF000GetErrorCodeDesc(byte errorCode)
        {
            switch (errorCode)
            {
                case cmdNotSupport:
                    return "֧ ";
                case cmdNotIdentify:
                    return "ʶ ";
                case errOperationNotSupport:
                    return "ò֧";
                case unknownError:
                    return "δ֪Ĵ ";
                case blockError:
                    return "ָĲ鲻ܱʹû򲻴 ";
                case blockLockedCntLock:
                    return "ָĲѾٴα";
                case blockLockedCntWrite:
                    return "ָĲѾܶݽид";
                case blockCntOperate:
                    return "ָĲ鲻ܱ";
                case blockCntLock:
                    return "ָĲ鲻ܱ";

                default:
                    return "";
            }
        }

         private void btnGetReaderInfo_Click(object sender, EventArgs e)
        {
            byte[] verInfo = new byte[2];
            byte[] trType = new byte[2];
            byte readerType = 0;
            byte inventoryScanTime = 0;
            int fCmdRet = 0x30;
            int fCmdRet2 = 0x30;
            ClearReaderInformation();
            if((cbAlreadyOpenedPortList.Items.Count == 0)&&(portIndex<256))
            InitializeBtnEnable();
            if (sender == btnGetReaderInfo)     //ͨ"GetReaderInformation"ťб˸¼
            {
                if (tbReaderAddr.Text != "")
                {
                    readerAddr = Convert.ToByte(tbReaderAddr.Text, 16);
                }
                else
                {
                    MessageBox.Show("дַ");
                    return;
                }
            }
            fCmdRet = StaticClassReaderA.GetReaderInformation(ref readerAddr, verInfo, 
                                                          ref readerType, trType, 
                                                          ref inventoryScanTime,
                                                          portIndex);
            if (fCmdRet == 0)
            {
                tbReadInfoAddr.Text = Convert.ToString(readerAddr, 16).PadLeft(2, '0').ToUpper();
                tbReaderInfoVersion.Text = Convert.ToString(verInfo[0], 10).PadLeft(2, '0') + "." +
                                           Convert.ToString(verInfo[1], 10).PadRight(2, '0');
                tbReaderInfoType.Text = GetReaderType(readerType);
                if ((trType[1] & 0x08) == 0x08)
                { tbReaderInfoProtocol.Text = "ISO/IEC 15693"; }
                tbReaderInfoInventoryScanTime.Text = inventoryScanTime.ToString().ToUpper();

                if (tabControl1.TabPages.IndexOf(tpTestMode) < 0)
                    tabControl1.TabPages.Insert(1, tpTestMode);

                if (tabControl1.TabPages.IndexOf(tpScanMode) < 0)
                    tabControl1.TabPages.Insert(2, tpScanMode);

                if (tabControl1.TabPages.IndexOf(tpCoustomDataLen) < 0)
                    tabControl1.TabPages.Insert(3, tpCoustomDataLen);

                if (tabControl1.TabPages.IndexOf(tpTransparent) < 0)
                    tabControl1.TabPages.Insert(4, tpTransparent);


                switch (tbReaderInfoType.Text)
                {
                    case "HF037":
                        HF037SREnable();
                        break;
                    case "HF036":
                    case "HF036SC":
                    case "HF036CF":
                        HF036SREnable();
                        break;
                    case "HF296A":
                    case "HF296":
                        HF296AEnable();
                        break;
                    case "HF293T":
                    case "HF093T":
                        HF293TEnanle();
                        break;
                    case "HF292T":
                    case "HF092T":
                        HF292TEnanle();
                        break;
                    case "HF291T":
                    case "HF091T":
                        HF291TEnanle();
                        break;
                    case "HF293A":
                    case "HF093A":
                        HF293AEnable();
                        break;
                    case "HF292A":
                    case "HF092A":
                        HF292AEnable();
                        break;
                    case "HF291F":
                    case "HF091F":
                        HF291FEnable();
                        break;
                    case "HF291":
                    case "HF091":
                        HF291Enable();
                        break;
                    case "HF203T":
                    case "HF003T":
                        HF203TEnable();
                        break;
                    case "HF202T":
                    case "HF002T":
                        HF202TEnable();
                        break;
                    case "HF201T":
                    case "HF001T":
                        HF201TEnable();
                        break;
                    case "HF203A":
                    case "HF003A":
                        HF203AEnable();
                        break;
                    case "HF202A":
                    case "HF002A":
                        HF202AEnable();
                        break;
                    case "HF201Lite":
                    case "HF001Lite":
                        HF201LiteEnable();
                        break;
                    case "HF201":
                    case "HF001":
                        HF201Enable();
                        break;
                }

                if ((string.Compare(tbReaderInfoVersion.Text, "06.00") > 0) ||
                   (tbReaderInfoType.Text == "HF001T") ||
                   (tbReaderInfoType.Text == "HF002T") ||
                   (tbReaderInfoType.Text == "HF003T") ||
                   (tbReaderInfoType.Text == "HF091T") ||
                   (tbReaderInfoType.Text == "HF093T") ||
                   (tbReaderInfoType.Text == "HF293T") ||
                   (tbReaderInfoType.Text == "HF092T") ||
                   (tbReaderInfoType.Text == "HF201T") ||
                   (tbReaderInfoType.Text == "HF202T") ||
                   (tbReaderInfoType.Text == "HF203T") ||
                   (tbReaderInfoType.Text == "HF291T") ||
                   (tbReaderInfoType.Text == "HF292T") ||
                   (tbReaderInfoType.Text == "HF293T") ||
                   (tbReaderInfoType.Text == "HF296") ||
                   (tbReaderInfoType.Text == "HF296A") ||
                   (tbReaderInfoType.Text == "HF001TSC") ||
                   (tbReaderInfoType.Text == "HF091TSC"))
                {
                    GetParseMode();
                }

                if (tbReaderInfoType.Text == "HF296A")
                {
                    btnGetReceiveChannelStatus_Click(null, null);
                    if (tbReceiveChannelStatus.Text == "RXOnly")
                        if (tabControl1.TabPages.IndexOf(tpTransparent) >= 0)
                        { tabControl1.TabPages.Remove(tpTransparent); }
                }


                if ((tbReaderInfoType.Text == "HF037") || (tbReaderInfoType.Text == "HF037SC") ||
                   (tbReaderInfoType.Text == "HF036") || (tbReaderInfoType.Text == "HF036SR") ||
                   (tbReaderInfoType.Text == "HF036CF"))
                {
                    label16.Text = "LEDָʾ";
                    label15.Text = "";
                    cbOutput1Status.Items.Clear();
                    cbOutput1Status.Items.Add("");
                    cbOutput1Status.Items.Add("");
                    cbOutput1Status.SelectedIndex = 0;

                    cbOutput2Status.Items.Clear();
                    cbOutput2Status.Items.Add("ɫ");
                    cbOutput2Status.Items.Add("ɫ");
                    cbOutput2Status.SelectedIndex = 0;
                }
                else
                {
                    label16.Text = "˿2";
                    label15.Text = "˿1";
                    cbOutput1Status.Items.Clear();
                    cbOutput1Status.Items.Add("͵ƽ");
                    cbOutput1Status.Items.Add("ߵƽ");
                    cbOutput1Status.SelectedIndex = 0;
                    cbOutput2Status.Items.Clear();
                    cbOutput2Status.Items.Add("͵ƽ");
                    cbOutput2Status.Items.Add("ߵƽ");
                    cbOutput2Status.SelectedIndex = 0;
                }
                if ((portIndex > 0) && (portIndex<256))
                    StatusBar1.Panels[1].Text = cbAlreadyOpenedPortList.SelectedItem.ToString();
            }
            fCmdRet2 = StaticClassReaderA.GetParseMode(ref readerAddr, ref Get_ParseMode, portIndex);
            if (fCmdRet2==0)
             {
                 if (Convert.ToInt32(Get_ParseMode & 0x80) == 0)
                 {
                     rbModulation10.Checked = true;
                     rbModulation10.Enabled = false;
                     rbModulation100.Enabled = true;
                 }
                 else
                 {
                     rbModulation100.Checked = true;
                     rbModulation100.Enabled = false;
                     rbModulation10.Enabled = true;
                 }
                 if (Convert.ToInt32(Get_ParseMode & 0x01) == 0)
                 {
                     rbParseModeWPPM.Checked = true;
                     rbParseModeWPPM.Enabled = false;
                     rbParseModeDPPM.Enabled = true;
                 }
                 else
                 {
                     rbParseModeDPPM.Checked = true;
                     rbParseModeDPPM.Enabled = false;
                     rbParseModeWPPM.Enabled = true;
                 }

                 if (Convert.ToInt32(Get_ParseMode & 0x20) == 0)
                 {
                     radioButton4.Checked = true;
                     radioButton4.Enabled = false;
                     radioButton3.Enabled = true;
                 }
                 else
                 {
                     radioButton3.Checked = true;
                     radioButton3.Enabled = false;
                     radioButton4.Enabled = true;
                 }
             }
            AddCmdLog(btnGetReaderInfo.Text, fCmdRet);
        }

        private void GetParseMode()
        {
            int fCmdRet;
            byte ParseMode = 0; ;
            fCmdRet = StaticClassReaderA.GetParseMode(ref readerAddr, ref ParseMode, portIndex);
            if (fCmdRet == 0)
            {
                if (ParseMode == 0x01)
                {
                    rbParseModeDPPM.Checked = true;
                    rbParseModeDPPM.Enabled = false;
                    rbModulation10.Checked = true;
                    rbModulation10.Enabled = false;
                }
                if (ParseMode == 0x81)
                {
                    rbParseModeDPPM.Checked = true;
                    rbParseModeDPPM.Enabled = false;
                    rbModulation100.Checked = true;
                    rbModulation100.Enabled = false;
                }
                if (ParseMode == 0x00)
                {
                    rbParseModeWPPM.Checked = true;
                    rbParseModeWPPM.Enabled = false;
                    rbModulation10.Checked = true;
                    rbModulation10.Enabled = false;
                }
                if (ParseMode == 0x80)
                {
                    rbParseModeWPPM.Checked = true;
                    rbParseModeWPPM.Enabled = false;
                    rbModulation100.Checked = true;
                    rbModulation100.Enabled = false;
                }                 
            }
            AddCmdLog("ȡǰдģʽ", fCmdRet);
        }

        private void SetParseMode()
        {
            int fCmdRet, fCmdRet2;
            byte ParseMode = 0;
            fCmdRet2 = StaticClassReaderA.GetParseMode(ref readerAddr, ref Get_ParseMode, portIndex);
                if ((rbParseModeDPPM.Checked == true) &&
                    (rbModulation10.Checked == true))
                {
                    ParseMode = Convert.ToByte((Get_ParseMode & 0x7F) | 01);
                }
                if ((rbParseModeDPPM.Checked == true) &&
                    (rbModulation100.Checked == true))
                {
                    ParseMode = Convert.ToByte(Get_ParseMode | 0x81);
                 }
                if ((rbParseModeWPPM.Checked == true) &&
                    (rbModulation10.Checked == true))
                {
                    ParseMode = Convert.ToByte(Get_ParseMode & 0x7E);
                 }
                if ((rbParseModeWPPM.Checked == true) &&
                    (rbModulation100.Checked == true))
                {
                    ParseMode = Convert.ToByte((Get_ParseMode & 0xFE)| 0x80);
                }

            fCmdRet = StaticClassReaderA.SetParseMode(ref readerAddr, ref ParseMode, portIndex);
            AddCmdLog("öдģʽ", fCmdRet);        
        }

        #region ClearReaderInfo                     
        private void ClearReaderInformation()
        {
            tbReadInfoAddr.Text = "";
            tbReaderInfoVersion.Text = "";
            tbReaderInfoType.Text = "";
            tbReaderInfoInventoryScanTime.Text = "";
            tbReaderInfoProtocol.Text = "";
        }
        #endregion

        #region  GetReaderTypeString
        private string GetReaderType(byte version)
        {
            switch (version)
            {
                case 0x45:
                    return "HF001";                    
                case 0x55:                    
                    return "HF036";
                case 0x58:
                    return "HF038";
                case 0x5C:
                    return "HF036SC";
                case 0x46:
                    return "HF001Lite";
                case 0x47:
                    return "HF003A";
                case 0x71:
                    return "HF003AD";
                case 0x48:
                    return "HF036CF";
                case 0xA1:
                    return "HF201";
                case 0xA2:
                    return "HF203A";
                case 0xA6:
                    return "HF201Lite";
                case 0x80:
                    return "HF091D";
                case 0x5B:
                    return "HF037";
                case 0x5D:
                    return "HF037SC";
                case 0x90:
                    return "HF291";
                case 0x30:
                    return "HF091F";
                case 0x3A:
                    return "HF296";
                case 0x3B:
                    return "HF296A";
                case 0xA7:
                    return "HF201D";
                case 0x4B:
                    return "HF002AD";
                case 0xA3:
                    return "HF202AD";
                case 0x81:
                    return "HF092A";
                case 0x82:
                    return "HF093A";
                case 0x93:
                    return "HF291F";
                case 0x91:
                    return "HF292A";
                case 0x92:
                    return "HF293A";
                case 0x70:                  //version 06.00
                    return "HF001D";
                case 0x8B:
                    return "HF203AGD";
                case 0x72:
                    return "HF203AD";
                case 0x97:
                    return "HF291D";
                case 0x7E:
                    return "HF001T";
                case 0x7F:
                    return "HF201T";
                case 0x8E:
                    return "HF091T";
                case 0x8F:
                    return "HF291T";
                case 0x83:
                    return "HF092T";
                case 0x84:                   
                    return "HF093T";              
                case 0x74:
                    return "HF002T";
                case 0x73:
                    return "HF003T";
                case 0x98:
                    return "HF202T";
                case 0x99:
                    return "HF203T";
                case 0x9A:
                    return "HF292T";
                case 0x9B:
                    return "HF293T";
                case 0x8A:
                    return "HF003AGD";
                case 0x50:
                    return "HF001TSC";
                case 0x51:
                    return "HF191T";
                default:
                    return "";
            }
        }
        #endregion

        private void btnOpenComPort_Click(object sender, EventArgs e)
        {
            int portNum = -1;
            int fCmdRet = 0x30;
            byte fbaud=0;
            try
            {
                this.Cursor = Cursors.WaitCursor;
                btnCloseComPort.Enabled = false;
                if (tbReaderAddr.Text == "")
                {
                    MessageBox.Show("дַ");
                    return;
                }
                readerAddr = Convert.ToByte(tbReaderAddr.Text, 16);
                ClearReaderInformation();
                if (cbComPortList.SelectedItem.ToString() == "Auto")
                {
                    fbaud =Convert.ToByte(ComboBox_baud.SelectedIndex);
                    fCmdRet = StaticClassReaderA.AutoOpenComPort(ref portNum, ref readerAddr, fbaud,ref portIndex);
                    if (fCmdRet == 0)
                        comboBox_baud2.SelectedIndex = fbaud;
                    AlreadyOpenPortList.Add(portNum);
                }
                else
                {
                    portNum = cbComPortList.SelectedIndex;
                    if (cbAlreadyOpenedPortList.Items.Count != 0)
                        foreach (int i in AlreadyOpenPortList)
                            if (portNum == i)
                            {
                                MessageBox.Show("Ѵ !");
                                return;
                            }
                    for (int n = 3; n >= 0; n--)
                    {
                        fbaud=Convert.ToByte(n);
                        fCmdRet = StaticClassReaderA.OpenComPort(portNum, ref readerAddr, fbaud, ref portIndex);
                        if (fCmdRet == 0)
                        {
                            comboBox_baud2.SelectedIndex = n;
                            break;
                        }
                    }
                }
                AddCmdLog(btnOpenComPort.Text, fCmdRet);
                if (fCmdRet == 0)
                {
                    fOpenComIndex = portIndex;
                    cbAlreadyOpenedPortList.Items.Add("COM" + portNum.ToString());
                    cbAlreadyOpenedPortList.SelectedIndex = cbAlreadyOpenedPortList.SelectedIndex + 1;
                    StatusBar1.Panels[1].Text = "COM" + portNum.ToString();

                    gbpsetbaud.Enabled = true;
                    gbpebpsetting.Enabled = true;
                    groupBox9.Enabled = true;
                    groupBox16.Enabled = true;
                    gbpacc.Enabled = true;
                }
                else
                {
                    MessageBox.Show("ͨѶ","ʾ");
                }
                
            }
            finally
            {
                this.Cursor = Cursors.Arrow;
                btnCloseComPort.Enabled = true;   
            }
        }

        #region AddCmdLog    //״̬,,errorCodeerrorCode
        private void AddCmdLog(string cmdStr, int cmdRet, byte errorCode)
        {
            try
            {
                if (!fIsAppClose)
                {
                    StatusBar1.Panels[0].Text = "";
                    StatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " +
                                                cmdStr + ": " +
                                                HF000GetReturnCodeDesc(cmdRet) + " " +
                                                HF000GetErrorCodeDesc(errorCode);
                }
            }
            finally
            {
                ;
            }
        }
        private void AddCmdLog(string cmdStr, int cmdRet)
        {
            try
            {
                if (!fIsAppClose)
                {
                    StatusBar1.Panels[0].Text = "";
                    StatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " +
                                                cmdStr + ": " +
                                                HF000GetReturnCodeDesc(cmdRet);
                }
            }
            finally
            {
                ;
            }
        }
        #endregion

        private void btnCloseComPort_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            string s;
            if (cbAlreadyOpenedPortList.Items.Count == 0 ||
                cbAlreadyOpenedPortList.SelectedItem == null)
            {
                MessageBox.Show("ѡҪرյĴ");
                return;
            }
            if (!GetCurrentUsePort())
            {
                MessageBox.Show("ѹر");
                return;
            }
            fCmdRet = StaticClassReaderA.CloseSpecComPort(portIndex);

            AddCmdLog(btnCloseComPort.Text, fCmdRet);
            if (fCmdRet == 0)
            {
                Label_Alarm.Visible = false;
                cbAlreadyOpenedPortList.Items.Remove("COM" + portIndex.ToString());
                if (cbAlreadyOpenedPortList.Items.Count != 0)
                {
                    cbAlreadyOpenedPortList.SelectedIndex = 0;
                    cbAlreadyOpenedPortList.Refresh();
                    s = cbAlreadyOpenedPortList.SelectedItem.ToString();
                    portIndex = Convert.ToInt16(s.Substring(3, (s.Length - 3)));
                    AlreadyOpenPortList.Remove(portIndex);
                }
                else
                {
                    InitializeBtnEnable();
                    foreach (Control ctl in this.Controls[1].Controls)      //ҵtabControlؼ,Controls[1]
                        if (ctl is TabPage)                                 //tabControlؼеtabPage
                    foreach(Control ctl1 in ctl.Controls )
                        if (ctl1 is GroupBox)                               //tabPageеGroupBox
                            foreach (System.Windows.Forms.Control ctl2 in ctl1.Controls)
                        {
                            if ((ctl2 is TextBox) && (ctl2.Name != "tbReaderAddr"))   //GroupBoxеTextBox
                                (ctl2 as TextBox).Text = "";
                        }
                    fOpenComIndex = -1;

                }
               
                lbUIDList.Items.Clear();
                cbUIDListforInfo.Items.Clear();
                cbUserUidList.Items.Clear();
            }
        }

        #region ȡǰʹõĴ
        private bool GetCurrentUsePort()
        {
            string temp;
            if ((fOpenComIndex > 0) && (fOpenComIndex < 256))
            {
                if (cbAlreadyOpenedPortList.Items.Count == 0 ||
                cbAlreadyOpenedPortList.SelectedItem == null)
                    return (false);
                temp = cbAlreadyOpenedPortList.SelectedItem.ToString();
                portIndex = Convert.ToInt32(temp.Substring(3, temp.Length - 3), 10);
                return (true);
            }
            else if ((fOpenComIndex > 1023) && (fOpenComIndex < 65535))
            {
                return (true);
            }
            else
            {
                return false;
            }  
        }
        #endregion

        private void cbAlreadyOpenedPortList_SelectedValueChanged(object sender, EventArgs e)
        {
            GetCurrentUsePort();
            readerAddr = 0xFF;
            btnGetReaderInfo_Click(null, null);            
        }

        private void btnSetRelay_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte relaySet = (byte)cbRelayControl.SelectedIndex;
            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴ڣ");
                return;
            }
            fCmdRet = StaticClassReaderA.SetRelay(ref readerAddr, ref relaySet, portIndex);
            AddCmdLog("", fCmdRet);
        }

        private void btnSetOutputStatus_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte outputSet = (byte)(cbOutput1Status.SelectedIndex + cbOutput2Status.SelectedIndex * 2);
            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            fCmdRet = StaticClassReaderA.SetGeneralOutput(ref readerAddr, ref outputSet, portIndex);
            AddCmdLog("", fCmdRet);
        }

        private void btnGetInoutStatus_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte inputStatus = 0xff;

            tbInputStatus.Text = "";
            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            fCmdRet = StaticClassReaderA.GetGeneralInput(ref readerAddr, ref inputStatus, portIndex);
            if (fCmdRet == 0)
            {
                if(inputStatus == 0)
                {
                    tbInputStatus.Text = "͵ƽ";
                }
                else
                {
                    tbInputStatus.Text = "ߵƽ";
                }
            }

            AddCmdLog("ȡ", fCmdRet);
        }

        private void btnWriteAddress_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte newReaderAddr = 0;

            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            if (tbAddressToWrite.Text == "")
            {
                MessageBox.Show("дַ");
                return;
            }
            newReaderAddr = Convert.ToByte(tbAddressToWrite.Text.Substring(0,2),16);
            fCmdRet = StaticClassReaderA.WriteComAdr(ref readerAddr,ref newReaderAddr,portIndex);
            if (fCmdRet == 0)
            {
                readerAddr = newReaderAddr;
                btnGetReaderInfo_Click(null, null);
            }
            AddCmdLog("ддַ", fCmdRet);
        }

        private void btnGetCurrentANT_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte ANTcurrentUsed = 0;

            tbANTCurrentUsed.Text = "";
            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            fCmdRet = StaticClassReaderA.GetANTStatus(ref readerAddr, ref ANTcurrentUsed, portIndex);
            if (fCmdRet == 0)
            {
                if (ANTcurrentUsed == 1)
                { tbANTCurrentUsed.Text = "1"; }
                else if (ANTcurrentUsed == 2)
                { tbANTCurrentUsed.Text = "2"; }
                else if (ANTcurrentUsed == 4)
                { tbANTCurrentUsed.Text = "3"; }
                else if (ANTcurrentUsed == 8)
                { tbANTCurrentUsed.Text = "4"; }
            }
            AddCmdLog("ȡ", fCmdRet);  

        }

        private void bntSetActiveANT_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte ANTSet = 0;

            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            if (rbANT1.Checked)
            { ANTSet = 1; }
            else if (rbANT2.Checked)
            { ANTSet = 2; }
            else if (rbANT3.Checked)
            { ANTSet = 4; }
            else if (rbANT4.Checked)
            { ANTSet = 8; }
            fCmdRet = StaticClassReaderA.SetActiveANT(ref readerAddr, ref ANTSet, portIndex);
            AddCmdLog("", fCmdRet);
        }

        private void btnWriteInventoryScanTime_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte inventoryScanTime = 30;

            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            inventoryScanTime = (byte)(cbInventoryScanTimeToWrite.SelectedIndex + 3);
            fCmdRet = StaticClassReaderA.WriteInventoryScanTime(ref readerAddr, ref inventoryScanTime, portIndex);
            if (fCmdRet == 0)
            {
                btnGetReaderInfo_Click(null, null);        
            }
            AddCmdLog("дѯӦʱ ", fCmdRet);
        }

        private void btnSetAccessTime_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte accessTimeToWrite = 0;

            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            accessTimeToWrite = (byte)(cbAccessTimeToSet.SelectedIndex);
            fCmdRet = StaticClassReaderA.SetAccessTime(ref readerAddr, ref accessTimeToWrite, portIndex);
            AddCmdLog("", fCmdRet);
        }

        private void btnGetAccessTime_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte AccessTime = 0;

            tbAccessTimeGetted.Text = "";
            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            fCmdRet = StaticClassReaderA.GetAccessTime(ref readerAddr, ref AccessTime, portIndex);
            if (fCmdRet == 0)
            { tbAccessTimeGetted.Text = AccessTime.ToString(); }
            AddCmdLog("ȡ", fCmdRet);
        }

        private void btnSetReceiveChannel_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte receiveChannelToSet = 0;

            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            receiveChannelToSet = (byte)((checkBSetRTXChannel.Checked ? 1 : 0) * 2 +
                                         (checkBSetRXChannel.Checked ? 1 : 0));
            fCmdRet = StaticClassReaderA.SetReceiveChannel(ref readerAddr, ref receiveChannelToSet, portIndex);
            AddCmdLog("", fCmdRet);
        }

        private void btnGetReceiveChannelStatus_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte receiveChannelGetted = 0;

            tbAccessTimeGetted.Text = "";
            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            fCmdRet = StaticClassReaderA.GetReceiveChannelStatus(ref readerAddr, ref receiveChannelGetted, portIndex);
            if (fCmdRet == 0)
            {
                if (receiveChannelGetted == 1)
                { tbReceiveChannelStatus.Text = "RXOnly"; }
                else if (receiveChannelGetted == 2)
                { tbReceiveChannelStatus.Text = "TX/RX + RXOnly"; }
                else if (receiveChannelGetted == 3)
                { tbReceiveChannelStatus.Text = "TX/RX"; }
            }
            AddCmdLog("ȡ", fCmdRet);
        }

        private void btnOpenRF_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;

            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            fCmdRet = StaticClassReaderA.OpenRf(ref readerAddr, portIndex);
            AddCmdLog(btnOpenRF.Text, fCmdRet);
        }

        private void btnCloseRF_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;

            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            fCmdRet = StaticClassReaderA.CloseRf(ref readerAddr, portIndex);
            AddCmdLog(btnCloseRF.Text, fCmdRet);
        }

        #region  16ַ֮໥ת
        private byte[] HexStringToByteArray(string s)
        {
            s = s.Replace(" ", "");
            byte[] buffer = new byte[s.Length / 2];
            for (int i = 0; i < s.Length; i += 2)
                buffer[i / 2] = (byte)Convert.ToByte(s.Substring(i, 2), 16);
            return buffer;
        }
        private string ByteArrayToHexString(byte[] data)
        {
            StringBuilder sb = new StringBuilder(data.Length * 3);
            foreach (byte b in data)
                sb.Append(Convert.ToString(b, 16).PadLeft(2, '0').PadRight(3, ' '));
            return sb.ToString().ToUpper();
        }
        #endregion

        private void btnStayQuite_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte errorCode = 0;
            byte[] uid = new byte[8];

            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            if ((rbAddressMode.Checked) &&
                ((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))

            {
                MessageBox.Show("ѡUID");
                return;
            }
            uid = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString()); 
            fCmdRet = StaticClassReaderA.StayQuiet(ref readerAddr,uid, ref errorCode, portIndex); 
            AddCmdLog(btnStayQuite.Text, fCmdRet, errorCode);
        }

        private void btnSelect_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte errorCode = 0;
            byte[] uid = new byte[8];

            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            if ((rbAddressMode.Checked) &&
                ((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))

            {
                MessageBox.Show("ѡUID");
                return;                    
            }
            uid = HexStringToByteArray( cbUIDListforInfo.SelectedItem.ToString());
            
            fCmdRet = StaticClassReaderA.Select(ref readerAddr,uid, ref errorCode, portIndex);
            AddCmdLog(btnSelect.Text, fCmdRet, errorCode);
        }

        #region   ȡĳЩstateֵ
        private byte GetState()
        {
            return (byte)(rbAddressMode.Checked ? 0 : 1);
        }
        private byte GetState(string writeType)
        {
            if (writeType.IndexOf("A") >= 0)
            {
                return (byte)((rbAddressMode.Checked) ? 0 : 1);
            }
            else
            {
                return (byte)((rbAddressMode.Checked) ? 8 : 9);
            }
        }
        private byte GetState(byte blocSize, string writeType, bool isCheckWriteType)
        {
            if (!isCheckWriteType)
            {
                if (blocSize == 4)
                { return (byte)(rbAddressMode.Checked ? 0 : 1); }
                else
                { return (byte)(rbAddressMode.Checked ? 4 : 5); }
            }
            else
            {
                if (blocSize == 4)
                {
                    if (writeType.IndexOf("A") >= 0)            //Aǩ,ÿ4ֽ
                    {
                        return (byte)((rbAddressMode.Checked) ? 0 : 1);
                    }
                    else                                        //Bǩ,ÿ4ֽ
                    {
                        return (byte)((rbAddressMode.Checked) ? 8 : 9);
                    }
                }
                else
                {
                    if (writeType.IndexOf("A") >= 0)            //Aǩ,ÿ8ֽ
                    {
                        return (byte)((rbAddressMode.Checked) ? 4 : 5);
                    }
                    else                                        //Bǩ,ÿ8ֽ
                    {
                        return (byte)((rbAddressMode.Checked) ? 0x0C : 0x0D);
                    }
                }
            
            }
        }
        #endregion

        private void btnResetToReady_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte state;
            byte errorCode = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 }; 

            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            if ((rbAddressMode.Checked) &&
                ((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))

            {
                MessageBox.Show("ѡUID");
                return;
            }
            if (rbAddressMode.Checked)
                UID = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString());
            else
                UID = null;
            state = GetState();
            fCmdRet = StaticClassReaderA.ResetToReady(ref readerAddr, ref state, UID, ref errorCode, portIndex);

            AddCmdLog(btnResetToReady.Text, fCmdRet, errorCode);
        }

        private void rbAddressMode_Click(object sender, EventArgs e)
        {
            cbUIDListforInfo.Enabled = rbAddressMode.Checked;
            btnSelect.Enabled = true;
            btnStayQuite.Enabled = true;
        }

        private void btnInventoryNoAFI_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte state = 0;
            byte AFI = 0;
            byte[] DSFIDAndUID = new byte[9];
            byte cardNumber = 0;
            string strDSFIDAndUID = "";

            cbUIDListforInfo.Items.Clear();
            cbUserUidList.Items.Clear();
            lbUIDList.Items.Clear();
            labelCardNum.Text = "0";
            tbSystemInfoData.Text = "";
            tbSystemInfo.Text = "";
            cbWriteType.Items.Clear();
            cbEndBlockNum.Items.Clear();
            cbBeginBlok.Items.Clear();
            cbBlockNumToOperation.Items.Clear();
            int n_time=0;
            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            if (sender == btnInventoryWithAFI)
            {
                if (tbAFI.Text == "")
                {
                    MessageBox.Show("AFI");
                    return;
                }
                AFI = Convert.ToByte(tbAFI.Text, 16);
                state = 1;
            }
            if (sender == btnUserInventoryWithAFI)
            {
                if (tbAFI.Text == "")
                {
                    MessageBox.Show("AFI");
                    return;
                }
                AFI = Convert.ToByte(tbAFI.Text, 16);
                state = 1;
            }

            fCmdRet = StaticClassReaderA.Inventory(ref readerAddr, ref state, ref AFI, DSFIDAndUID, ref cardNumber, portIndex);
            if (fCmdRet == 0)
            {
                strDSFIDAndUID = ByteArrayToHexString(DSFIDAndUID).Replace(" ","");
                cbUIDListforInfo.Items.Add(strDSFIDAndUID.Substring(2, 16));          
                cbUIDListforInfo.SelectedIndex = 0;
                cbUserUidList.Items.Add(strDSFIDAndUID.Substring(2, 16));
                cbUserUidList.SelectedIndex = 0;
                lbUIDList.Items.Add(strDSFIDAndUID);
                labelCardNum.Text = cardNumber.ToString();
            }
            AddCmdLog(((Button)sender).Text, fCmdRet);
            fCmdRet = StaticClassReaderA.GetInventoryTime(ref n_time, portIndex);
            StatusBar1.Panels[2].Text = ":" + cardNumber.ToString();
            StatusBar1.Panels[3].Text = "ѯʱ:" + n_time.ToString() + "ms";
        }

        private void btnGetSystemInfo_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte errorCode = 0;
            byte state = 0;
            byte informationFlag = 0;
            byte DSFID = 0;
            byte AFI = 0;
            byte ICReference = 0;
            byte[] UIDI = { 0, 0, 0, 0, 0, 0, 0, 0 };
            byte[] UIDO = new byte[8];
            byte[] menorySize = new byte[2];
            byte blockSize= 0,blockNum = 0;
            string tagWriteType = "";
            string FirmName = "";
            int i;

            btnReadSingleBlock.Enabled = false;
            btnReadMultiBlock.Enabled = false;
            btnWriteSingleBlock.Enabled = false;
            btnLcokBlock.Enabled = false;
            tbSystemInfoData.Text = "";
            tbSystemInfo.Text = "";
            cbWriteType.Items.Clear();
            cbEndBlockNum.Items.Clear();
            cbBeginBlok.Items.Clear();
            cbBlockNumToOperation.Items.Clear();
            cbMaxBlockNum.Items.Clear();
            cbBlockSize.Items.Clear();

            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            if ((rbAddressMode.Checked) &&
                ((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))

            {
                MessageBox.Show("ѡUID");
                return;
            }
            state = GetState();
           
            if (rbAddressMode.Checked)
                UIDI = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString());
            fCmdRet = StaticClassReaderA.GetSystemInformation(ref readerAddr, ref state, UIDI, ref informationFlag, UIDO, 
                                                          ref DSFID, ref AFI, menorySize,
                                                          ref ICReference, ref errorCode, portIndex);
            if (fCmdRet == 0)
            {
                tbSystemInfoData.Text = ByteArrayToHexString(UIDO).Replace(" ","");
                tbSystemInfo.Text = "UID0: " + ByteArrayToHexString(UIDO).Replace(" ", "");
                if ((informationFlag & 0x01) == 0x01)
                {
                    tbSystemInfoData.Text = tbSystemInfoData.Text + " " + Convert.ToString(DSFID, 16).PadLeft(2, '0').ToUpper();
                    tbSystemInfo.Text = tbSystemInfo.Text + " " + "DSFID: " + Convert.ToString(DSFID, 16).PadLeft(2, '0').ToUpper();
                }
                if ((informationFlag & 0x02) == 0x02)
                {
                    tbSystemInfoData.Text = tbSystemInfoData.Text + " " + Convert.ToString(AFI, 16).PadLeft(2, '0').ToUpper();
                    tbSystemInfo.Text = tbSystemInfo.Text + " " + "AFI: " + Convert.ToString(AFI, 16).PadLeft(2, '0').ToUpper();          
                }
                if ((informationFlag & 0x04) == 0x04)
                {
                    tbSystemInfoData.Text = tbSystemInfoData.Text + " " + ByteArrayToHexString(menorySize).Replace(" ", "");
                    tbSystemInfo.Text = tbSystemInfo.Text + " " + "MemorySize: " + ByteArrayToHexString(menorySize).Replace(" ", "");
                }
                if ((informationFlag & 0x08) == 0x08)
                {
                    tbSystemInfoData.Text = tbSystemInfoData.Text + " " + Convert.ToString(ICReference, 16).PadLeft(2, '0').ToUpper();
                    tbSystemInfo.Text = tbSystemInfo.Text + " " + "ICReference: " + Convert.ToString(ICReference, 16).PadLeft(2, '0').ToUpper();
                }

                GetTagInfo(UIDO[6], UIDO[7],ref FirmName, ref blockSize, ref blockNum, ref tagWriteType);

                cbWriteType.Items.Add("A ");
                cbWriteType.Items.Add("B ");                
                if (tagWriteType.IndexOf("B") != -1)
                { cbWriteType.SelectedIndex = 1; }
                else
                { cbWriteType.SelectedIndex = 0; }

                cbBlockSize.Items.Add("4");
                cbBlockSize.Items.Add("8");                
                if (blockSize == 8)
                { cbBlockSize.SelectedIndex = 1; }
                else
                { cbBlockSize.SelectedIndex = 0; }                
                
                for (i = 0; i < 256; i++)
                {
                    cbMaxBlockNum.Items.Add(i.ToString());
                }
                cbMaxBlockNum.SelectedIndex = blockNum - 1;
                StatusBar1.Panels[2].Text = FirmName + "," + " "+tagWriteType + "," + blockSize.ToString() +
                                            "ֽ/," + blockNum.ToString() + "";
            }
            AddCmdLog(btnGetSystemInfo.Text, fCmdRet, errorCode);
        }

        private void GetTagInfo(byte FirmCode, byte OtherCode,ref string FirmName,  ref byte BlockSize, ref byte BlockNum, ref string TagType)
        {
            switch (FirmCode)
            {
                case 0x02:
                    BlockSize = 4;
                    BlockNum = 16;
                    TagType = "B";
                    FirmName = "STMicroelectronics"; 
                    break;
                case 0x04:
                    BlockSize = 4;
                    BlockNum = 28;
                    TagType = "B";
                    FirmName = "Philips Semiconductors";
                    break;
                case 0x05:
                    BlockSize = 4;
                    BlockNum = 58;
                    if (OtherCode == 0xE0)
                        BlockNum = 250;
                    else if (OtherCode == 0x60)
                        BlockNum = 58; 
                    TagType = "B";
                    FirmName = "Infineon";
                    break;
                case 0x07:
                    BlockSize = 4;
                    BlockNum = 64;
                    TagType = "A";
                    FirmName = "Texas Instruments";
                    break;
                case 0x08:
                    BlockSize = 8;
                    BlockNum = 250;
                    TagType = "A/B";
                    FirmName = "Fujitsu";
                    break;
                case 0x16:                                  
                    BlockSize= 4;                      
                    BlockNum = 14;
                    TagType = "A"; 
                    FirmName = "EM Microelectronic" ;
                    break;
                default:
                    FirmName = "";
                    break;
             }
        }

        private void btnNewInventoryScanNoAFI_Click(object sender, EventArgs e)
        {
            int i,fCmdRet = 0x30;
            byte state = 6;             //ĬϲAFIInventoryScan
            byte AFI = 0;
            byte[] DSFIDAndUID = new byte[2300];
            byte cardNumber = 0;
            ListViewItem aListItem = new ListViewItem();
            string s ="",FirmName = "",strDSFIDAndUID = "";
            byte BlockSize  = 0;
            byte BlockNum = 0;
            string TagType ="";
            int n_time=0;

            cbUIDListforInfo.Items.Clear(); 
            lbUIDList.Items.Clear(); 
            labelCardNum.Text = "0";
            tbSystemInfoData.Text = "";
            tbSystemInfo.Text = "";            
            cbWriteType.Items.Clear();
            cbEndBlockNum.Items.Clear();
            cbBeginBlok.Items.Clear();
            cbBlockNumToOperation.Items.Clear();
            cbMaxBlockNum.Items.Clear();
            cbBlockSize.Items.Clear();

            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }

            if (sender == btnContinueInventoryScanNoAFI)
            {
                state = 2;
            }
            else if (sender == btnNewInventoryScanWithAFI)
            {
                if (tabControl1.SelectedIndex == 4)
                {
                    if (tbAFI.Text == "")
                    {
                        MessageBox.Show("AFI");
                        return;
                    }
                    AFI = Convert.ToByte(tbAFI.Text, 16);
                }
                else
                {
                    if (tbAFI.Text == "")
                    {
                        MessageBox.Show("AFI");
                        return;
                    }
                    AFI = Convert.ToByte(tbAFI.Text, 16);
                }
                state = 7;
            }
            else if (sender == btnContinueInventoryScanWithAFI)
            {
                if (tabControl1.SelectedIndex == 4)
                {
                    if (tbAFI.Text == "")
                    {
                        MessageBox.Show("AFI");
                        return;
                    }
                    AFI = Convert.ToByte(tbAFI.Text, 16);
                }
                else
                {
                    if (tbAFI.Text == "")
                    {
                        MessageBox.Show("AFI");
                        return;
                    }
                    AFI = Convert.ToByte(tbAFI.Text, 16);
                }

                state = 3;
            }
            fCmdRet = StaticClassReaderA.Inventory(ref readerAddr, ref state, ref AFI, DSFIDAndUID, ref cardNumber, portIndex);

            if ((fCmdRet == 0x0A) || (fCmdRet == 0x0B) || (fCmdRet == 0x0E))                                                    
            {
                Array.Resize(ref DSFIDAndUID, cardNumber * 9);
                strDSFIDAndUID = ByteArrayToHexString(DSFIDAndUID).Replace(" ", "");
                if (fIsTestMode)
                {
                    DeleteRepeatUID(strDSFIDAndUID,ref DSFIDAndUIDList);
                    totalCardNumber = (byte)(DSFIDAndUIDList.Length / 18);
                    if (fCmdRet == 0x0E)
                    {
                        while (lvTestMode.Items.Count < totalCardNumber)     //Ϊ˲˸
                        {
                            aListItem = lvTestMode.Items.Add((lvTestMode.Items.Count + 1).ToString());
                            aListItem.SubItems.Add("");
                            aListItem.SubItems.Add("");
                            aListItem.SubItems.Add(""); 
                        }
                        while (lvTestMode.Items.Count > totalCardNumber)
                        { lvTestMode.Items.Remove(lvTestMode.Items[lvTestMode.Items.Count - 1]); }
                        for (i = 0; i < totalCardNumber; i++)
                        {

                            aListItem = lvTestMode.Items[i];
                            GetTagInfo(Convert.ToByte(DSFIDAndUIDList.Substring(18 * i + 14, 2), 16),
                                       Convert.ToByte(DSFIDAndUIDList.Substring(18 * i + 16, 2), 16),
                                       ref FirmName, ref BlockSize, ref BlockNum, ref TagType);
                            ChangeSubItem(aListItem, 1, FirmName);
                            s = DSFIDAndUIDList.Substring(18 * i + 2, 16);
                            ChangeSubItem(aListItem, 2, s);
                            s = DSFIDAndUIDList.Substring(18 * i, 2);
                            ChangeSubItem(aListItem, 3, s);//
                        }
                    }
                    if (fCmdRet == 0x0B)
                    {
                        btnNewInventoryScanNoAFI_Click(btnContinueInventoryScanNoAFI, null);  
                    }
                }
                else
                {
                    if ((fCmdRet == 0x0E) || (fCmdRet == 0x0B))
                    {
                        for (i = 0; i < cardNumber; i++)
                        {
                            s = strDSFIDAndUID.Substring(18 * i , 18);
                            cbUIDListforInfo.Items.Add(s.Substring(2,16));
                            cbUserUidList.Items.Add(s.Substring(2,16));
                            lbUIDList.Items.Add(s);
                            labelCardNum.Text = cardNumber.ToString();
                        }
                        if (cardNumber > 0)
                        {
                            cbUIDListforInfo.SelectedIndex = 0;
                            cbUserUidList.SelectedIndex = 0;
                        }
                    }                 
                }
            }
            if ((fIsTestMode) && (totalCardNumber != 0))
                AddCmdLog(((Button)sender).Text, 0);
            else
                AddCmdLog(((Button)sender).Text, fCmdRet);
            fCmdRet = StaticClassReaderA.GetInventoryTime(ref n_time, portIndex);
            StatusBar1.Panels[2].Text = ":" + cardNumber.ToString();
            StatusBar1.Panels[3].Text = "ѯʱ:" + n_time.ToString()+"ms";
        }

        private void ChangeSubItem(ListViewItem ListItem, int subItemIndex, string ItemText)
        {
            if (ListItem.SubItems[subItemIndex].Text != ItemText)
            {
                ListItem.SubItems[subItemIndex].Text = ItemText;    
            }
        }

        private void DeleteRepeatUID(string tempUIDString, ref string unipueUIDString)
        { 
            int i ; 
            string  s;
            for (i = 0; i < tempUIDString.Length/18; i++)
            {
                s = tempUIDString.Substring(18*i,18);
                if (unipueUIDString.IndexOf(s) < 0)
                    unipueUIDString = unipueUIDString + s;
            } 
        }
    
        private void btnWriteAFI_Click(object sender, EventArgs e)
        {
            byte state = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };
            byte errorCode = 0;
            byte AFI = 0;
            int fCmdRet = 0x30;

            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            if ((rbAddressMode.Checked) &&
                ((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))

            {
                MessageBox.Show("ѡUID");
                return;
            }
            if (tbAFI.Text == "")
            {
                MessageBox.Show("AFI");
                return;
            }
            AFI = Convert.ToByte(tbAFI.Text, 16);
            if (rbAddressMode.Checked)
                UID = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString());
            if (cbWriteType.SelectedItem == null)
                return;
            state = GetState(cbWriteType.SelectedItem.ToString());
            fCmdRet = StaticClassReaderA.WriteAFI(ref readerAddr, ref state, UID, AFI, ref errorCode, portIndex);

            AddCmdLog(btnWriteAFI.Text, fCmdRet, errorCode);
        }

        private void cbMaxBlockNum_SelectedIndexChanged(object sender, EventArgs e)
        {
            int i;
            cbBlockNumToOperation.Items.Clear();
            cbBeginBlok.Items.Clear();
            cbEndBlockNum.Items.Clear();
            for (i = 0; i < cbMaxBlockNum.SelectedIndex + 1; i++)
            {
                cbBlockNumToOperation.Items.Add(i.ToString());
                cbBeginBlok.Items.Add(i.ToString());
                cbEndBlockNum.Items.Add(i.ToString());
            }
            cbBlockNumToOperation.SelectedIndex = 0;
            cbBeginBlok.SelectedIndex = 0;
            cbEndBlockNum.SelectedIndex = 0;
        }

        private void btnWriteDSFID_Click(object sender, EventArgs e)
        {
            byte state = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };
            byte errorCode = 0;
            byte DSFID = 0;
            int fCmdRet = 0x30;

            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            if ((rbAddressMode.Checked) &&
                ((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))

            {
                MessageBox.Show("ѡUID");
                return;
            }
            if (tbDSFID.Text == "")
            {
                MessageBox.Show("DSFID");
                return;
            }
            DSFID = Convert.ToByte(tbDSFID.Text, 16);

            if (rbAddressMode.Checked)
                UID = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString());
            if (cbWriteType.SelectedItem == null)
                return;
            state = GetState(cbWriteType.SelectedItem.ToString());
            fCmdRet = StaticClassReaderA.WriteDSFID(ref readerAddr, ref state, UID, DSFID, ref errorCode, portIndex);

            AddCmdLog(btnWriteDSFID.Text, fCmdRet, errorCode);
        }

        private void btnLockAFI_Click(object sender, EventArgs e)
        {
            byte state = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };
            byte errorCode = 0;
            int fCmdRet = 0x30;

            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪶˿");
                return;
            }
            if ((rbAddressMode.Checked) &&
                ((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))

            {
                MessageBox.Show("ѡUID");
                return;
            }
            if (MessageBox.Show(this, "AFI ?", "", MessageBoxButtons.OKCancel) == DialogResult.Cancel)
                return;

            if (rbAddressMode.Checked)
                UID = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString());
            if (cbWriteType.SelectedItem == null)
                return;
            state = GetState(cbWriteType.SelectedItem.ToString());
            fCmdRet = StaticClassReaderA.LockAFI(ref readerAddr, ref state, UID, ref errorCode, portIndex);

            AddCmdLog(btnLockAFI.Text, fCmdRet, errorCode);            
        }

        private void btnLockDSFID_Click(object sender, EventArgs e)
        {
            byte state = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };
            byte errorCode = 0;
            int fCmdRet = 0x30;


            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            if ((rbAddressMode.Checked) &&
                ((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))

            {
                MessageBox.Show("ѡUID");
                return;
            }
            if (MessageBox.Show(this, "DSFID ?", "", MessageBoxButtons.OKCancel) == DialogResult.Cancel)
                return;
            if (rbAddressMode.Checked)
                UID = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString());
            if (cbWriteType.SelectedItem == null)
                return;
            state = GetState(cbWriteType.SelectedItem.ToString());
            fCmdRet = StaticClassReaderA.LockDSFID(ref readerAddr, ref state, UID, ref errorCode, portIndex);

            AddCmdLog(btnLockDSFID.Text, fCmdRet, errorCode);
        }

        private void btnReadSingleBlock_Click(object sender, EventArgs e)
        {
            byte state = 0;            
            byte errorCode = 0;
            int fCmdRet = 0x30;
            byte blockNum = 0;
            byte blockSecStatus = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };
            tbDataReaded.Text = "";
            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
            }
            
            if ((rbAddressMode.Checked) &&
                ((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))
            {
                MessageBox.Show("ѡUID");
                return;
            }

            if ((cbWriteType.SelectedItem == null) || (cbMaxBlockNum.SelectedItem == null) || (cbBlockSize.SelectedItem == null) || (cbBlockNumToOperation.SelectedItem == null))
            {
                return;
            }
            blockNum = (byte)cbBlockNumToOperation.SelectedIndex;
            state = GetState((byte)(cbBlockSize.SelectedIndex * 4 + 4), cbBlockSize.SelectedItem.ToString(), false);
            byte[] data = new byte[cbBlockSize.SelectedIndex * 4 + 4];

            if (rbAddressMode.Checked)
                UID = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString());                

            fCmdRet = StaticClassReaderA.ReadSingleBlock(ref readerAddr, ref state, UID, blockNum, ref blockSecStatus, data, ref errorCode, portIndex);
            if (fCmdRet == 0)
                tbDataReaded.Text = blockSecStatus.ToString("x2") + " " + ByteArrayToHexString(data).Replace(" ", "");
            AddCmdLog(btnReadSingleBlock.Text, fCmdRet, errorCode);
        }

        private void cbBlockSize_SelectedIndexChanged(object sender, EventArgs e)
        {
            tbDataToWrite.MaxLength = (cbBlockSize.SelectedIndex  * 4 + 4) * 2;
        }

        private void btnWriteSingleBlock_Click(object sender, EventArgs e)
        {
            byte state = 0;            
            byte errorCode = 0;
            int fCmdRet = 0x30;
            byte blockNum = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };

            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
            }


            if (tbDataToWrite.Text.Length != (cbBlockSize.SelectedIndex  * 4 + 4) * 2)
            {
                MessageBox.Show("ȷ"); 
                return;
            }
            if ((rbAddressMode.Checked) &&
               ((cbUIDListforInfo.Items.Count == 0) ||
                (cbUIDListforInfo.SelectedItem == null)))
            {
                MessageBox.Show("ѡUID");
                return;
            }
            byte[] data = new byte[cbBlockSize.SelectedIndex * 4 + 4];
            data = HexStringToByteArray(tbDataToWrite.Text);
            if (rbAddressMode.Checked)
                UID = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString());
            blockNum = (byte)cbBlockNumToOperation.SelectedIndex;
            if (cbWriteType.SelectedItem == null)
                return;
            state = GetState((byte)(cbBlockSize.SelectedIndex * 4 + 4), cbWriteType.SelectedItem.ToString(), true);

            fCmdRet = StaticClassReaderA.WriteSingleBlock(ref readerAddr, ref state, UID, blockNum, data, ref errorCode, portIndex);

            AddCmdLog(btnWriteSingleBlock.Text, fCmdRet, errorCode);
        }

        private void btnLcokBlock_Click(object sender, EventArgs e)
        {
            byte state = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };
            byte errorCode = 0;
            byte blockNum = 0;
            int fCmdRet = 0x30;
            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            if ((rbAddressMode.Checked) &&
                ((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))

            {
                MessageBox.Show("ѡUID");
                return;
            }

            if (MessageBox.Show(this, "ָ ?", "", MessageBoxButtons.OKCancel) == DialogResult.Cancel)
                return;

            UID = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString());
            if (cbWriteType.SelectedItem == null)
                return;
            state = GetState(cbWriteType.SelectedItem.ToString());
            blockNum = (byte)cbBlockNumToOperation.SelectedIndex;
            fCmdRet = StaticClassReaderA.LockBlock(ref readerAddr, ref state, UID, blockNum, ref errorCode, portIndex);

            AddCmdLog(btnLcokBlock.Text, fCmdRet, errorCode);  
        }

        private void btnReadMultiBlock_Click(object sender, EventArgs e)
        {
            byte state = 0;
            byte errorCode = 0;
            int fCmdRet = 0x30;
            byte startBlockNum = 0;
            byte blockCount = 0;
            byte blockSize = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };
            int i;


            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
            }
            if ((rbAddressMode.Checked) &&
                ((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))

            {
                MessageBox.Show("ѡUID");
                return;
            }


            startBlockNum = (byte)cbBeginBlok.SelectedIndex;
            if (cbEndBlockNum.SelectedIndex < startBlockNum)
            {
                MessageBox.Show("Ŀ");
                return;
            }
            blockCount = (byte)(cbEndBlockNum.SelectedIndex - startBlockNum + 1);
            blockSize = (byte)(cbBlockSize.SelectedIndex * 4 + 4);
            if (cbBlockSize.SelectedIndex == 0)            //BlockSizeΪ4ʱ,һܶȡ28
            {
               if (blockCount > 28)            
               {
                   MessageBox.Show("ܳ28");
                   return;
               }
            }
            else                                            //BlockSizeΪ8ʱ,һܶȡ15
            {
                if (blockCount > 15)   
                {
                    MessageBox.Show("ܳ15");
                    return;
                }
            }

            byte[] data = new byte[ blockSize * blockCount];
            byte[] blockSecStatus = new byte[blockCount];
            if (cbWriteType.SelectedItem == null)
                return;
            state = GetState(blockSize, cbWriteType.SelectedItem.ToString(), false);
            if (rbAddressMode.Checked)
                UID = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString());

            fCmdRet = StaticClassReaderA.ReadMultipleBlock(ref readerAddr, ref state, UID, startBlockNum, blockCount, 
                                                       blockSecStatus, data, ref errorCode, portIndex);
            if (fCmdRet == 0)
            {
                frmMultipleBlockDataList frmdata = new frmMultipleBlockDataList();
                frmdata.Text = cbUIDListforInfo.SelectedItem.ToString() 
                               + "  " + startBlockNum.ToString() 
                               + " - " + cbEndBlockNum.SelectedIndex.ToString();
                string temp = ByteArrayToHexString(data).Replace(" ","");
                for (i = startBlockNum; i < cbEndBlockNum.SelectedIndex + 1; i++)
                {
                    frmdata.ListView1.Items.Add(i.ToString());
                    frmdata.ListView1.Items[i - startBlockNum].SubItems.Add(Convert.ToString(blockSecStatus[i - startBlockNum], 16).PadLeft(2, '0') 
                                                                            + " " 
                                                                            + temp.Substring((i - startBlockNum) * blockSize * 2, blockSize * 2));
                }
                frmdata.Show();
            }                
            AddCmdLog(btnReadMultiBlock.Text, fCmdRet, errorCode);
        }

        private void tbReaderAddr_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = "0123456789ABCDEF\b".IndexOf(char.ToUpper(e.KeyChar)) < 0;  //  "\b"˸             
        }

        private void tbCmdTramsparentRead_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = "0123456789ABCDEF\b ".IndexOf(char.ToUpper(e.KeyChar)) < 0;  //  "\b"˸
        }

        private void btnStartTestMode_Click(object sender, EventArgs e)
        {
            btnStartTestMode.Enabled = false;
            btnStopTestMode.Enabled = true;
            fIsTestMode = true;
            timerTestMode.Enabled = true;
        }

        private void btnStopTestMode_Click(object sender, EventArgs e)
        {
            timerTestMode.Enabled = false;
            fIsTestMode = false;
            btnStartTestMode.Enabled = true;
            btnStopTestMode.Enabled = false;            
        }

        private void timer1_Tick(object sender, EventArgs e)
        {            
            timerTestMode.Enabled = false;
            DSFIDAndUIDList = "";
            totalCardNumber = 0;            
            btnNewInventoryScanNoAFI_Click(btnNewInventoryScanNoAFI, null);
            if (( fIsTestMode == true) && (!fIsAppClose))
            timerTestMode.Enabled = true;
        }

        private void tabControl1_Selecting(object sender, TabControlCancelEventArgs e)      
        {
            fIsTestMode = false;
            fIsScanMode = false;
            if (GetCurrentUsePort())
            {
                if (tabControl1.SelectedTab == tpTestMode)             //л"ģʽ"ҳ        
                {
                    lvTestMode.Items.Clear();
                    btnStartTestMode.Enabled = true;
                    btnStopTestMode.Enabled = false;
                }
                if (tabControl1.SelectedTab == tpScanMode)
                {
                    label42.Text = "ɨģʽ";
                    textBox1.Text = "";
                    btnDisplayOff.Enabled = false;
                    btnDisplayOn.Enabled = false;
                    btnStartScanMode.Enabled = true;
                    btnStopScanMode.Enabled = false;
                    GetScanModeSetting();
                    btnGetUserBlockSize_Click(null, null);
                }
                if (tabControl1.SelectedTab == tpCoustomDataLen)
                {
                    btnUserReadMultiBlock.Enabled = false;
                    btnUserReadSingleBlock.Enabled = false;
                    btnUserWriteSingleBlock.Enabled = false;
                    btnGetUserBlockSize_Click(null, null);
                }
            }
        }

        private void btnStartScanMode_Click(object sender, EventArgs e)
        {
            byte[] scanModeData = new byte[11];
            int fCmdRet = 0x30;
            int Reader_bit0=0;
            int Reader_bit1=0;
            int Reader_bit2=0;
            int Reader_bit3=0;
            int Reader_bit4=0;
            int Reader_bit5=0;
            int Reader_bit6=0;
            int Reader_bit7=0;
            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            Reader_bit0 = (byte)((sender == btnStartScanMode) ? 1 : 0);
            if (Reader_bit0 == 0)
            {
                fIsScanMode = false;
            }
            else
            {
                fIsScanMode = true;
            }
            Reader_bit1 = (byte)((radioButton8.Checked ==true) ? 0 : 1);
            Reader_bit2 = (byte)((radioButton10.Checked == true) ? 0 : 1);
            Reader_bit3 = (byte)((radioButton12.Checked == true) ? 0 : 1);
            Reader_bit4 = (byte)((radioButton14.Checked == true) ? 0 : 1);
            Reader_bit5 = (byte)((radioButton16.Checked == true) ? 0 : 1);
            Reader_bit6 = (byte)((radioButton18.Checked == true) ? 0 : 1);
            Reader_bit7 = (byte)((radioButton20.Checked == true) ? 0 : 1);
            scanModeData[0] =(byte)(Reader_bit0 * 1 +Reader_bit1 * 2 +Reader_bit2 * 4 +Reader_bit3 * 8 +Reader_bit4 * 16 +Reader_bit5 * 32 + Reader_bit6 * 64 +Reader_bit7 * 128);
            scanModeData[1] = (byte)((rbScanModeWithComAddr.Checked) ? 1 : 0);         //1:comAddr;0:

            scanModeData[1] = (byte)((rbScanModeWithUID.Checked) ? (scanModeData[1] |= 0x02) : (scanModeData[1] &= 0xFD));//1:UID

            scanModeData[1] = (byte)((rbScanModeIncludeSpecifyBlock.Checked) ? (scanModeData[1] |= 0x04) : (scanModeData[1] &= 0xFB));

            scanModeData[1] = (byte)((rbScanModeWithSecWord.Checked) ? (scanModeData[1] |= 0x08) : (scanModeData[1] &= 0xF7));

            scanModeData[1] = (byte)((rbScanModeHex.Checked) ? (scanModeData[1] |= 0x10) : (scanModeData[1] &= 0xEF));

            scanModeData[1] = (byte)((rbScanModeSwitchRF.Checked) ? (scanModeData[1] |= 0x20) : (scanModeData[1] &= 0xDF));

            scanModeData[1] = (byte)((rbScanModeBuzzerOn.Checked) ? (scanModeData[1] |= 0x40) : (scanModeData[1] &= 0xBF));

            scanModeData[1] = (byte)((rbScanModeLedFlicker.Checked) ? (scanModeData[1] |= 0x80) : (scanModeData[1] &= 0x7F));
        
            scanModeData[2] = Convert.ToByte(cbScanModeStartBlock.SelectedIndex);
            scanModeData[3] = (byte)cbScanModeBlockCount.SelectedIndex;

            scanModeData[4] = (byte)cbScanModeStartByte.SelectedIndex;
            scanModeData[5] = (byte)cbScanModeByteCount.SelectedIndex;

            if (!checkBScanModeCoustomSpaceMark.Checked)
            {
                scanModeData[6] = (byte)(1 << cbScanModeSpaceMark.SelectedIndex);
            }
            else
            {
                scanModeData[6] = 0x80;
                scanModeData[7] = Convert.ToByte(tbScanModeCoustomSpaceMark.Text);
            }

            if (!checkBScanModeCoustomEndMark.Checked)
            {
                scanModeData[8] = (byte)(1 << cbScanModeEndMark.SelectedIndex);
            }
            else
            {
                scanModeData[8] = 0x80;
                scanModeData[9] = Convert.ToByte(tbScanModeCoustomEndMark.Text);
            }
            scanModeData[10] = 0x00;

            fCmdRet = StaticClassReaderA.SetScanMode(ref readerAddr, scanModeData, portIndex);
            AddCmdLog(((Button)sender).Text, fCmdRet);

            if (fCmdRet == 0)
            {
                if (Convert.ToInt32(scanModeData[0] & 0x10) == 0)
                {
                    radioButton14.Checked = true;
                    button2.Enabled = false;
                    button3.Enabled = false;
                }
                else
                {
                    radioButton13.Checked = true;
                    button2.Enabled = true;
                    button3.Enabled = true;
                }
                if (sender == btnStartScanMode)
                {
                    timerScanMode.Enabled = true;
                    btnStopScanMode.Enabled = true;
                    btnStartScanMode.Enabled = false;
                    btnDisplayOn.Enabled = false;
                    btnDisplayOff.Enabled = true;
                    label42.Text = "ɨģʽ";
                }
                else
                {               
                    timerScanMode.Enabled = false;
                    btnStopScanMode.Enabled = false;
                    btnStartScanMode.Enabled = true;
                    btnDisplayOn.Enabled = false;
                    btnDisplayOff.Enabled = false;
                    label42.Text = "ɨģʽ";
                }
            }            
        }

        private void DisplayScanModeData()
        {
            byte[] ScanModeData = new byte[40960];
            int ScanModeDataLength = 0;
            int fCmdRet = 0x30;
            string s;

            fCmdRet = StaticClassReaderA.ReadScanModeData(ScanModeData, ref ScanModeDataLength, portIndex);

            if (fCmdRet == 0)
            {
                if (radioButton8.Checked)
                {
                    if (rbScanModeHex.Checked)
                    {
                        Array.Resize(ref ScanModeData, ScanModeDataLength);
                        s = ByteArrayToHexString(ScanModeData);
                    }
                    else
                    {
                        s = new string(System.Text.Encoding.ASCII.GetChars(ScanModeData));
                    }
                    tbScanModeData.AppendText(s + "\r\n");
                    tbScanModeData.AppendText(Environment.NewLine);
                }
                else
                {
                    if (radioButton5.Checked)
                    {
                        Array.Resize(ref ScanModeData, ScanModeDataLength);
                        s = ByteArrayToHexString(ScanModeData);
                    }
                    else
                    {
                        s = new string(System.Text.Encoding.ASCII.GetChars(ScanModeData));
                    }
                    tbScanModeData.AppendText(s + "\r\n");
                    tbScanModeData.AppendText(Environment.NewLine);
                }
                
            }

            if (fCmdRet == 1)
            {
                tbScanModeData.AppendText(DateTime.Now.ToLongTimeString() + "  " + "û .\r\n");
            }   
        }

        private void GetScanModeSetting()
        {
            byte[] scanModeSetting = new byte[11];
            int fCmdRet = 0x30;
            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }

            fIsScanMode = false;
            timerScanMode.Enabled = false;

            fCmdRet = StaticClassReaderA.GetScanModeStatus(ref readerAddr, scanModeSetting, portIndex);

            if (fCmdRet == 0)
            {
                if ((scanModeSetting[0] & 0x02) == 0)
                {
                    radioButton8.Checked = true;
                    groupBox10.Enabled = false;
                    groupBox14.Enabled = false;
                    groupBox15.Enabled = false;
                    groupBox23.Enabled = true;
                    groupBox24.Enabled = true;
                    groupBox25.Enabled = true;
                    groupBox27.Enabled = true;
                }
                else
                {
                    radioButton7.Checked = true;
                    groupBox10.Enabled = true;
                    groupBox14.Enabled = true;
                    groupBox15.Enabled = true;
                    groupBox23.Enabled = false;
                    groupBox24.Enabled = false;
                    groupBox25.Enabled = false;
                    groupBox27.Enabled = false;
                }

                if ((scanModeSetting[0] & 0x04) == 0)
                    radioButton10.Checked = true;
                else
                    radioButton9.Checked = true;

                if ((scanModeSetting[0] & 0x08) == 0)
                    radioButton12.Checked = true;
                else
                    radioButton11.Checked = true;

                if ((scanModeSetting[0] & 0x10) == 0)
                {
                    radioButton14.Checked = true;
                    button2.Enabled = false;
                    button3.Enabled = false;
                }
                else
                {
                    radioButton13.Checked = true;
                    button2.Enabled = true;
                    button3.Enabled = true;
                }

                if ((scanModeSetting[0] & 0x20) == 0)
                    radioButton16.Checked = true;
                else
                    radioButton15.Checked = true;

                if ((scanModeSetting[0] & 0x40) == 0)
                    radioButton18.Checked = true;
                else
                    radioButton17.Checked = true;

                if ((scanModeSetting[0] & 0x80) == 0)
                    radioButton20.Checked = true;
                else
                    radioButton19.Checked = true;
                //
                if ((scanModeSetting[1] & 0x01) == 1)
                    rbScanModeWithComAddr.Checked = true;
                else
                    rbScanModeNoComAddr.Checked = true;


                if ((scanModeSetting[1] & 0x02) == 0x02)
                    rbScanModeWithUID.Checked = true;
                else
                    rbScanModeNoUID.Checked = true;

                if ((scanModeSetting[1] & 0x04) == 0x04)
                {
                    rbScanModeIncludeSpecifyBlock.Checked = true;
                    groupBox26.Enabled = true;
                }
                else
                {
                    rbScanModeExcludeSpecifyBlock.Checked = true;
                    groupBox26.Enabled = false;
                }

                if ((scanModeSetting[1] & 0x08) == 0x08)
                    rbScanModeWithSecWord.Checked = true;
                else
                    rbScanModeNoSecWord.Checked = true;

                if ((scanModeSetting[1] & 0x10) == 0x10)
                    rbScanModeHex.Checked = true;
                else
                    rbScanModeAscii.Checked = true;

                if ((scanModeSetting[1] & 0x20) == 0x20)
                    rbScanModeSwitchRF.Checked = true;
                else
                    rbScanModeNotSwitchRF.Checked = true;

                if ((scanModeSetting[1] & 0x40) == 0x40)
                    rbScanModeBuzzerOn.Checked = true;
                else
                    rbScanModeBuzzerOff.Checked = true;

                if ((scanModeSetting[1] & 0x80) == 0x80)
                    rbScanModeLedFlicker.Checked = true;
                else
                    rbScanModeLedNoFlicker.Checked = true;
                //rbScanModeWithComAddr.Checked = ((byte)(scanModeSetting[1] & 0x01) == 0x01) ? true : false; //1:comAddr;0:
                //rbScanModeWithUID.Checked =  ((byte)(scanModeSetting[1] & 0x02) == 0x02) ? true : false;
                //rbScanModeIncludeSpecifyBlock.Checked = ((byte)(scanModeSetting[1] & 0x03) == 0x03) ? true : false;
                //rbScanModeWithSecWord.Checked = ((byte)(scanModeSetting[1] & 0x04) == 0x04) ? true : false;
                //rbScanModeHex.Checked = ((byte)(scanModeSetting[1] & 0x10) == 0x10) ? true : false;
                //rbScanModeSwitchRF.Checked = ((byte)(scanModeSetting[1] & 0x20) == 0x20) ? true : false;
                //rbScanModeBuzzerOn.Checked = ((byte)(scanModeSetting[1] & 0x40) == 0x40) ? true : false;
                //rbScanModeLedFlicker.Checked = ((byte)(scanModeSetting[1] & 0x80) == 0x80) ? true : false;

                cbScanModeStartBlock.SelectedIndex = scanModeSetting[2];
                cbScanModeBlockCount.SelectedIndex = scanModeSetting[3];

                cbScanModeStartByte.SelectedIndex = scanModeSetting[4];
                cbScanModeByteCount.SelectedIndex = scanModeSetting[5];

                if ((byte)(scanModeSetting[6] & 0x80) == 0x80)
                {
                    checkBScanModeCoustomSpaceMark.Checked = true;
                    tbScanModeCoustomSpaceMark.Text = Convert.ToString(scanModeSetting[7]);
                }
                else
                {
                    if (scanModeSetting[6]< 0x10)
                        cbScanModeSpaceMark.SelectedIndex = scanModeSetting[6] - 1;
                    else
                        cbScanModeSpaceMark.SelectedIndex = (scanModeSetting[6] >> 4) + 3;
                }

                if ((byte)(scanModeSetting[8] & 0x80) == 0x80)
                {
                    checkBScanModeCoustomEndMark.Checked = true;
                    tbScanModeCoustomEndMark.Text = Convert.ToString(scanModeSetting[9]);
                }
                else
                {
                    if (scanModeSetting[8] < 0x10)
                        cbScanModeEndMark.SelectedIndex = scanModeSetting[8] - 1;
                    else
                        cbScanModeEndMark.SelectedIndex = (scanModeSetting[8] >> 4) + 3;
                }
                if (scanModeSetting[0] == 0x01)
                {
                    fIsScanMode = true;
                    timerScanMode.Enabled = true;
                    btnStartScanMode.Enabled = false;
                    btnDisplayOff.Enabled = true;
                    btnDisplayOn.Enabled = false;
                    btnStopScanMode.Enabled = true;
                    label42.Text = "ɨģʽ";
                }
                else
                {
                    fIsScanMode = false;
                    timerScanMode.Enabled = false;
                    btnStartScanMode.Enabled = true;
                    btnDisplayOff.Enabled = false;
                    btnDisplayOn.Enabled = false;
                    btnStopScanMode.Enabled = false;
                    label42.Text = "ɨģʽ";
                }
            }
                      
        }

        private void timerScanMode_Tick(object sender, EventArgs e)
        {
            timerScanMode.Enabled = false;
            DisplayScanModeData();
            if ((fIsScanMode) && (!fIsAppClose))
                timerScanMode.Enabled = true;
        }

        private void btnCleanScanModeData_Click(object sender, EventArgs e)
        {
            tbScanModeData.Text = "";
        }

        private void btnDisplayOn_Click(object sender, EventArgs e)
        {
            timerScanMode.Enabled = true;
            btnDisplayOn.Enabled = false;
            btnDisplayOff.Enabled = true;
        }

        private void btnDisplayOff_Click(object sender, EventArgs e)
        {
            timerScanMode.Enabled = false;
            btnDisplayOn.Enabled = true;
            btnDisplayOff.Enabled = false;
        }
        
        private void btnTransparentRead_Click(object sender, EventArgs e)
        {
            byte[] cmdData;
            byte[] respData = new byte[256];
            int fCmdRet = 0x30;
            string temp;
            byte errorCode = 0;
            byte respLength = 0;            
            byte feedBackDataLength = 0;   

            tbResponeTramsparentRead.Text = "";
            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            if (tbCmdTramsparentRead.Text == "")
            {
                MessageBox.Show("");
                return;
            }
            temp = tbCmdTramsparentRead.Text.Replace(" ", "");
            cmdData = new byte[temp.Length / 2];

            respLength = Convert.ToByte(temp.Substring(0,2),16);
            temp = temp.Remove(0,2);
            cmdData = HexStringToByteArray(temp);

            fCmdRet = StaticClassReaderA.TransparentRead(ref readerAddr, respLength, (byte)cmdData.Length, cmdData, ref feedBackDataLength,
                                                     respData, ref errorCode, portIndex);
            Array.Resize(ref respData, feedBackDataLength);

            if (fCmdRet == 0)
            {
                tbResponeTramsparentRead.Text = (ByteArrayToHexString(respData));
            }
            AddCmdLog(btnTransparentRead.Text, fCmdRet, errorCode);
            
        }

        private void btnTransparentWrite_Click(object sender, EventArgs e)
        {
            byte[] cmdData;
            byte[] respData = new byte[256];
            byte[] option = new byte[4];
            int fCmdRet = 0x30;
            string temp;
            byte errorCode = 0;
            byte respLength = 0, feedBackDataLength = 0;

            tbResponeTramsparentWrite.Text = "";
            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            if (tbCmdTramsparentWrite.Text == "")
            {
                MessageBox.Show("");
                return;
            }
            temp = tbCmdTramsparentWrite.Text.Replace(" ", "");

            if (temp.Length < 10)
            {
                MessageBox.Show("ȷ");
                return;
            }

            option = HexStringToByteArray(temp.Substring(0,8));
            respLength = Convert.ToByte(temp.Substring(8,2),16);

            cmdData = HexStringToByteArray(temp.Substring(10,temp.Length - 10));

            fCmdRet = StaticClassReaderA.TransparentWrite(ref readerAddr, option, respLength, (byte)cmdData.Length, cmdData,
                                                      ref feedBackDataLength, respData, ref errorCode, portIndex);

            Array.Resize(ref respData, feedBackDataLength);
            if (fCmdRet == 0)
            {
                tbResponeTramsparentWrite.Text = (ByteArrayToHexString(respData));
            }

            AddCmdLog(btnTransparentWrite.Text, fCmdRet, errorCode);
        }

        private void btnTransparentSpecifyResponeTime_Click(object sender, EventArgs e)
        {
            byte[] cmdData;
            byte[] respData = new byte[256];
            byte[] repTime = new byte[2];
            int fCmdRet = 0x30;
            string temp;
            byte errorCode = 0;
            byte respLength = 0, feedBackDataLength = 0;

            tbResponeTransparentSpecifyResponeTime.Text = "";
            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
                return;
            }
            if (btnCmdTransparentSpecifyResponeTime.Text == "")
            {
                MessageBox.Show("");
                return;
            }
            temp = btnCmdTransparentSpecifyResponeTime.Text.Replace(" ", "");

            if (temp.Length < 6)
            {
                MessageBox.Show("ȷ");
                return;
            }

            repTime = HexStringToByteArray(temp.Substring(0, 4));
            respLength = Convert.ToByte(temp.Substring(4,2),16);

            cmdData = HexStringToByteArray(temp.Substring(6,temp.Length - 6));

            fCmdRet = StaticClassReaderA.TransparentCustomizedCmd(ref readerAddr, repTime, respLength, (byte)cmdData.Length, cmdData,
                                                              ref feedBackDataLength, respData, ref errorCode, portIndex);

            Array.Resize(ref respData, feedBackDataLength);
            if (fCmdRet == 0)
            {
                tbResponeTransparentSpecifyResponeTime.Text = (ByteArrayToHexString(respData));
            }
            AddCmdLog("Ӧʱ͸", fCmdRet, errorCode);
 
        }

        private void btnSetUserBlockSize_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte userBlockSize = 0;

            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
            }

            userBlockSize = (byte)(cbUserBlockSizeSet.SelectedIndex + 1);
            fCmdRet = StaticClassReaderA.SetUserDefinedBlockLength(ref readerAddr,
                                                               ref userBlockSize, 
                                                               portIndex);
            AddCmdLog("", fCmdRet);
        }

        private void btnGetUserBlockSize_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte userBlockSize = 0;

            tbUserBlockSizeGet.Text = "";
            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
            }

            fCmdRet = StaticClassReaderA.GetUserDefinedBlocklength(ref readerAddr,
                                                               ref userBlockSize,
                                                               portIndex);
            if (fCmdRet == 0)
            {
                tbUserBlockSizeGet.Text = " " + Convert.ToString(userBlockSize, 10).PadLeft(2,'0');
                textBox1.Text = " " + Convert.ToString(userBlockSize, 10).PadLeft(2, '0');
                UserDefineBlockSize = userBlockSize;
                tbUserDataToWrite.MaxLength = UserDefineBlockSize * 2;
            }
            AddCmdLog("ȡ", fCmdRet);

        }

        private void btnUserNewInventoryScanNoAFI_Click(object sender, EventArgs e)
        {
            cbUserUidList.Items.Clear();
            sender = btnNewInventoryScanNoAFI;

            if (sender == btnUserContinueInventoryScanNoAFI)
                sender = btnContinueInventoryScanNoAFI;

            else if (sender == btnUserNewInventoryScanWithAFI)
                sender = btnNewInventoryScanWithAFI;

            else if (sender == btnUserContinueInventoryScanWithAFI)
                sender = btnContinueInventoryScanWithAFI;

            btnNewInventoryScanNoAFI_Click(sender,e);
        }

        private void btnUserReadSingleBlock_Click(object sender, EventArgs e)
        {
            byte state = 0;
            byte errorCode = 0;
            int fCmdRet = 0x30;
            byte blockNum = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };
            byte[] data = new byte[8];

            tbUserDataGetted.Text = "";
            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
            }

            blockNum = (byte)cbUserBlockNumber.SelectedIndex;

            state = 0xA0;
            if (!rbtnUserAddressMode.Checked)
            { state = 0xA1; }
            

            if ((rbtnUserAddressMode.Checked) &&
                ((cbUserUidList.Items.Count == 0) ||
                 (cbUserUidList.SelectedItem == null)))
            {
                MessageBox.Show("ѡUID");
                return;
            }

            if (rbtnUserAddressMode.Checked)
            UID = HexStringToByteArray(cbUserUidList.SelectedItem.ToString());

            fCmdRet = StaticClassReaderA.CustomizedReadSingleBlock(ref readerAddr, ref state, UID, blockNum, data, ref errorCode, portIndex);
            if (fCmdRet == 0)
            {
                Array.Resize(ref data, UserDefineBlockSize + 1);
                tbUserDataGetted.Text = ByteArrayToHexString(data).Replace(" ", "").Insert(2," ");
            }
            AddCmdLog(btnUserReadSingleBlock.Text, fCmdRet, errorCode);
        }

        private void btnUserReadMultiBlock_Click(object sender, EventArgs e)
        {
            byte state = 0;
            byte errorCode = 0;
            int fCmdRet = 0x30;
            byte startBlockNum = 0;
            byte blockCount = 0;
            byte blockSize = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };
            int i;

            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
            }
            if ((rbAddressMode.Checked) &&
                ((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))
            {
                MessageBox.Show("ѡUID");
                return;
            }

            startBlockNum = (byte)cbUserStartBlockNumber.SelectedIndex;
            if (cbUserEndBlockNumber.SelectedIndex < startBlockNum)
            {
                MessageBox.Show("ݿѡ");
                return;
            }
            blockCount = (byte)(cbUserEndBlockNumber.SelectedIndex - startBlockNum + 1);
            blockSize = UserDefineBlockSize;

            byte[] data = new byte[(blockSize + 1) * blockCount];
            byte[] blockSecStatus = new byte[blockCount];

            state = 0xA0;
            if (!rbAddressMode.Checked)
                state = 0xA1;
            if (rbtnUserAddressMode.Checked)
                UID = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString());

            fCmdRet = StaticClassReaderA.CustomizedReadMultipleBlock(ref readerAddr, ref state, UID, startBlockNum, blockCount,
                                                                 data, ref errorCode, portIndex);
            if (fCmdRet == 0)
            {
                frmMultipleBlockDataList frmdata = new frmMultipleBlockDataList();
                string temp = ByteArrayToHexString(data).Replace(" ", "");
                string s;

                for (i = startBlockNum; i < cbUserEndBlockNumber.SelectedIndex + 1; i++)
                {
                    s = temp.Substring((i - startBlockNum) * (blockSize + 1) * 2, (blockSize + 1) * 2);
                    frmdata.ListView1.Items.Add(i.ToString());
                    frmdata.ListView1.Items[i - startBlockNum].SubItems.Add(s.Insert(2," "));

                }
                frmdata.Show();
            }
            AddCmdLog(btnReadMultiBlock.Text, fCmdRet, errorCode);
        }

        private void btnUserWriteSingleBlock_Click(object sender, EventArgs e)
        {
            byte state = 0;
            byte errorCode = 0;
            int fCmdRet = 0x30;
            byte blockNum = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };

            if (!GetCurrentUsePort())
            {
                MessageBox.Show("򿪴");
            }

            if (tbUserDataToWrite.Text.Length != (UserDefineBlockSize * 2))
            {
                MessageBox.Show("ȷ");
                return;
            }

            if ((rbAddressMode.Checked) &&
               ((cbUIDListforInfo.Items.Count == 0) ||
                (cbUIDListforInfo.SelectedItem == null)))
            {
                MessageBox.Show("ѡUID");
                return;
            }

            byte[] data = new byte[UserDefineBlockSize];
            data = HexStringToByteArray(tbUserDataToWrite.Text);

            if (rbtnUserAddressMode.Checked)
            UID = HexStringToByteArray(cbUserUidList.SelectedItem.ToString());
            blockNum = (byte)cbUserBlockNumber.SelectedIndex;
            if (cbUserWriteType.SelectedIndex == 0)
            {
                state = 0xA0;
                if (!rbtnUserAddressMode.Checked)
                    state = 0xA1;
            }
            else 
            {
                state = 0xA8;
                if (!rbtnUserAddressMode.Checked)
                    state = 0xA9;
            }

            fCmdRet = StaticClassReaderA.CustomizedWriteSingleBlock(ref readerAddr, ref state, UID, blockNum, data,UserDefineBlockSize, ref errorCode, portIndex);

            AddCmdLog(btnWriteSingleBlock.Text, fCmdRet, errorCode);
        }

        private void cbUserMaxBlock_SelectedIndexChanged(object sender, EventArgs e)
        {
            int i;
            cbUserBlockNumber.Items.Clear();
            cbUserStartBlockNumber.Items.Clear();
            cbUserEndBlockNumber.Items.Clear();
            for (i = 0; i < cbUserMaxBlockNum.SelectedIndex + 1; i++)
            {
                cbUserBlockNumber.Items.Add(i.ToString());
                cbUserStartBlockNumber.Items.Add(i.ToString());
                cbUserEndBlockNumber.Items.Add(i.ToString());
            }
            cbUserBlockNumber.SelectedIndex = 0;
            cbUserStartBlockNumber.SelectedIndex = 0;
            cbUserEndBlockNumber.SelectedIndex = 0;
        }


        private void rbParseModeWPPM_Click(object sender, EventArgs e)
        {
            rbParseModeDPPM.Enabled = true;
            rbParseModeWPPM.Enabled = false;
            SetParseMode();
        }

        private void rbParseModeDPPM_Click(object sender, EventArgs e)
        {
            rbParseModeDPPM.Enabled = false;
            rbParseModeWPPM.Enabled = true;
            SetParseMode();
        }

        private void rbModulation100_Click(object sender, EventArgs e)
        {
            rbModulation10.Enabled = true;
            rbModulation100.Enabled = false;
            SetParseMode();
        }

        private void rbModulation10_Click(object sender, EventArgs e)
        {
            rbModulation100.Enabled = true;
            rbModulation10.Enabled = false;
            SetParseMode();
        }

        private void cbUIDListforInfo_SelectedIndexChanged(object sender, EventArgs e)
        {
            if ((tbReaderInfoType.Text != "HF001Lite") &&
                (tbReaderInfoType.Text != "HF201Lite"))
            {
                gbpAFI.Enabled = true;
                gbpDSFID.Enabled = true;
                btnGetSystemInfo.Enabled = true;
            }
            gbpOtherCmd.Enabled = true;
        }

        private void rbSelectMode_Click(object sender, EventArgs e)
        {
            btnSelect.Enabled = false;
            btnStayQuite.Enabled = false;
            cbUIDListforInfo.Enabled = rbAddressMode.Checked;
        }

        private void cbBeginBlok_SelectedIndexChanged(object sender, EventArgs e)
        {
            btnReadMultiBlock.Enabled = true;
        }

        private void cbBlockNumToOperation_SelectedIndexChanged(object sender, EventArgs e)
        {            
            btnReadSingleBlock.Enabled = true;
            btnReadMultiBlock.Enabled = true;
            btnWriteSingleBlock.Enabled = true;
            btnLcokBlock.Enabled = true;
        }

        private void cbUserBlockNumber_SelectedIndexChanged(object sender, EventArgs e)
        {
            btnUserReadMultiBlock.Enabled = true;
            btnUserReadSingleBlock.Enabled = true;
            btnUserWriteSingleBlock.Enabled = true;
        }

        private void frmHF000Demo_FormClosing(object sender, FormClosingEventArgs e)
        {
            fIsAppClose = true;
            fIsScanMode = true;
            fIsTestMode = true;
        }

        private void cbComPortList_SelectedIndexChanged(object sender, EventArgs e)
        {
            ComboBox_baud.Items.Clear();
            if(cbComPortList.SelectedIndex ==0)
            {
              ComboBox_baud.Items.Add("19200bps");
              ComboBox_baud.Items.Add("38400bps");
              ComboBox_baud.Items.Add("57600bps");
              ComboBox_baud.Items.Add("115200bps");
              ComboBox_baud.SelectedIndex=3;
            }
            else
            {
              ComboBox_baud.Items.Add("Auto");
              ComboBox_baud.SelectedIndex=0;
            }
        }

        private void groupBox7_Enter(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
              byte _ParseMode=0;
              int fCmdRet2;
              fCmdRet2 = StaticClassReaderA.GetParseMode(ref readerAddr, ref Get_ParseMode, portIndex);
              if(radioButton1.Checked)
              {
                  Get_ParseMode = Convert.ToByte(Get_ParseMode | 0x08);
                 switch (comboBox_baud2.SelectedIndex)
                 {
                   case 0: 
                       _ParseMode=Convert.ToByte(Get_ParseMode & 0xF9);
                         break ;
                   case 1:
                      _ParseMode=Convert.ToByte((Get_ParseMode & 0xFB) | 0x02 );
                         break;
                   case 2: 
                      _ParseMode=Convert.ToByte((Get_ParseMode & 0xFD) | 0x04) ;
                         break;
                   case 3:
                      _ParseMode=Convert.ToByte(Get_ParseMode | 0x06);
                         break;
                 }
              }
              else
                  _ParseMode=Get_ParseMode;
              if(fCmdRet2==0)
              {
                fCmdRet =StaticClassReaderA.SetParseMode(ref readerAddr,ref _ParseMode, portIndex);
                if (fCmdRet != 0) 
                {
                 // RadioButton_parsemode1.Checked := false;
                //  Radiobutton_depth1.Checked := false;
                }
              }
              AddCmdLog("", fCmdRet);
        }

        private void rbParseModeDPPM_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void radioButton3_Click(object sender, EventArgs e)
        {
               byte _ParseMode=0;
               int fCmdRet2;
               fCmdRet2 = StaticClassReaderA.GetParseMode(ref readerAddr, ref Get_ParseMode, portIndex);
                  if(fCmdRet2==0)
                  {
                      if(radioButton3.Checked)
                      {
                        radioButton3.Enabled=false;
                        radioButton3.Checked = true;
                        radioButton4.Enabled=true;
                        radioButton4.Checked = false;
                         _ParseMode =Convert.ToByte(Get_ParseMode | 0x20);
                        fCmdRet = StaticClassReaderA.SetParseMode(ref readerAddr,ref _ParseMode,portIndex);
                        if (fCmdRet != 0) 
                        {
                          radioButton3.Checked = false;
                          radioButton3.Enabled = true ;
                          radioButton4.Checked = true;
                          radioButton4.Enabled = false;
                        }
                      }
                  }
                  AddCmdLog("", fCmdRet);

        }

        private void radioButton4_Click(object sender, EventArgs e)
        {
             byte _ParseMode=0;
             int fCmdRet2;
             fCmdRet2 = StaticClassReaderA.GetParseMode(ref readerAddr, ref Get_ParseMode, portIndex);
              if(fCmdRet2==0)
              {
                  if(radioButton4.Checked)
                  {
                        radioButton3.Enabled=true;
                        radioButton3.Checked = false;
                        radioButton4.Enabled=false;
                        radioButton4.Checked = true;
                    _ParseMode = Convert.ToByte(Get_ParseMode & 0xDF);
                    fCmdRet = StaticClassReaderA.SetParseMode(ref readerAddr,ref _ParseMode,portIndex);
                    if (fCmdRet != 0)
                    {
                        radioButton3.Checked = true;
                        radioButton3.Enabled = false;
                        radioButton4.Checked = false;
                        radioButton4.Enabled = true;
                    }
                  }
              }
              AddCmdLog("ֹ ", fCmdRet);

        }

        private void radioButton3_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void tpScanMode_Click(object sender, EventArgs e)
        {

        }

        private void button2_Click(object sender, EventArgs e)
        {
          byte _Sync;
          _Sync=1;
          fCmdRet = StaticClassReaderA.SyncScan(ref readerAddr, _Sync, portIndex);
          AddCmdLog("еǰɨ", fCmdRet);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            byte _Sync;
            _Sync = 0;
            fCmdRet = StaticClassReaderA.SyncScan(ref readerAddr, _Sync, portIndex);
            AddCmdLog("ͣǰɨ", fCmdRet);
        }

        private void radioButton7_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void radioButton8_Click(object sender, EventArgs e)
        {
            groupBox10.Enabled = false;
            groupBox14.Enabled = false;
            groupBox15.Enabled = false;
            groupBox23.Enabled = true;
            groupBox24.Enabled = true;
            groupBox25.Enabled = true;
            groupBox27.Enabled = true;
            radioButton17.Checked = true;
            radioButton19.Checked = true;

        }

        private void radioButton7_Click(object sender, EventArgs e)
        {
            groupBox10.Enabled = true;
            groupBox14.Enabled = true;
            groupBox15.Enabled = true;
            groupBox23.Enabled = false;
            groupBox24.Enabled = false;
            groupBox25.Enabled = false;
            groupBox27.Enabled = false;
        }

        private void rbScanModeExcludeSpecifyBlock_Click(object sender, EventArgs e)
        {
            groupBox26.Enabled = false;
            rbScanModeNoSecWord.Checked = true;
        }

        private void rbScanModeIncludeSpecifyBlock_Click(object sender, EventArgs e)
        {
            groupBox26.Enabled = true;
        }

        private void frmHFReader09Demo_Load(object sender, EventArgs e)
        {
            int i;
            for (i = 0; i < 40; i++)
                comboBox1.Items.Add(Convert.ToString(i)+"("+Convert.ToString((0.25*(i+1)))+"W)");
            for (i = 0; i < 100; i++)
                comboBox2.Items.Add(Convert.ToString(i));
            comboBox1.SelectedIndex = 39;
            comboBox2.SelectedIndex = 99;

        }

        private void button6_Click(object sender, EventArgs e)
        {
             byte _Pwr=0;
             byte _PwrVal=0;
                  fCmdRet=StaticClassReaderA.GetPwr(ref readerAddr, ref _Pwr,ref _PwrVal,portIndex) ;
                  if(fCmdRet==0)
                  {
                      Label_Alarm.Visible = true;
                       if(Convert.ToInt32(_Pwr & 0x80)==0)
                       {
                           Label_Alarm.ForeColor = Color.LawnGreen;
                       }
                       else
                       {
                           Label_Alarm.ForeColor =Color.Red;
                       }
                       textBox2.Text=Convert.ToString(_Pwr & 0x7F);
                       textBox3.Text=Convert.ToString(_PwrVal);
                  }
                  AddCmdLog("ȡ", fCmdRet);
        }

        private void button4_Click(object sender, EventArgs e)
        {
              byte _Pwr;
               _Pwr=Convert.ToByte(comboBox1.SelectedIndex);
              fCmdRet=StaticClassReaderA.SetPwr(ref readerAddr,ref _Pwr, portIndex);
               AddCmdLog("ù", fCmdRet);
        }

        private void button5_Click(object sender, EventArgs e)
        {
              byte _PwrVal;
               _PwrVal=Convert.ToByte(comboBox2.SelectedIndex);
               fCmdRet=StaticClassReaderA.SetPwrByValue(ref readerAddr,ref _PwrVal, portIndex);
               AddCmdLog("ùʼ", fCmdRet);
        }

        private void button7_Click(object sender, EventArgs e)
        {
                byte _AntValid=0;

               fCmdRet=StaticClassReaderA.CheckAntenna(ref readerAddr,ref _AntValid,portIndex) ;
               if(fCmdRet==0)
                { 
                     if(Convert.ToInt32(_AntValid & 0x80)==0)
                     {
                      textBox4.Text="ѱ궨";
                     }
                     else
                     {
                      textBox4.Text="δ궨";
                     }
                     if(Convert.ToInt32(_AntValid & 0x01)==0)
                     {
                       textBox5.Text="";
                     }
                     else
                     {
                         if(Convert.ToInt32(_AntValid & 0x02)==0)
                          textBox5.Text="쳣()";
                         if(Convert.ToInt32(_AntValid & 0x02)==2)
                          textBox5.Text="쳣()";
                     }
               }
               AddCmdLog("״̬", fCmdRet);
        }

        private void radioButton4_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void gbpTagAccessTime_Enter(object sender, EventArgs e)
        {

        }

        private void button21_Click(object sender, EventArgs e)
        {
            listView1.Items.Clear();
            string str = "";
            Information.IP = "";
            Information.usename = "";
            Information.dsname = "";
            Information.mac = "";
            Information.portnum = "";
            Information.tup = "";
            Information.rm = "";
            Information.cm = "";
            Information.ct = "";
            Information.fc = "";
            Information.dt = "";
            Information.br = "";
            Information.pr = "";
            Information.bb = "";
            Information.rc = "";
            Information.ml = "";
            Information.md = "";
            Information.di = "";
            Information.dp = "";
            Information.gi = "";
            Information.nm = "";
            byte[] data = new byte[1024];
            ListViewItem aListItem = new ListViewItem();
            try
            {
                Socket sock = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);//ʼһScoketʵϰ,UDP
                IPEndPoint iep = new IPEndPoint(IPAddress.Broadcast, 65535);//ʼһ͹㲥ָ˿ڵ˿ʵ
                EndPoint ep = (EndPoint)iep;
                sock.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);//øscoketʵķʽ
                string request = "X";//ʼҪ͵
                byte[] buffer = Encoding.ASCII.GetBytes(request);
                sock.SendTo(buffer, iep);
                for (int i = 0; i < 255; i++)
                {
                    byte[] buffer1 = new byte[1000];
                    sock.ReceiveTimeout = 10;
                    int m_count = sock.ReceiveFrom(buffer1, ref ep);
                    if (m_count > 0)
                    {
                        aListItem = listView1.Items.Add((listView1.Items.Count + 1).ToString());
                        aListItem.SubItems.Add("");
                        aListItem.SubItems.Add("");
                        aListItem.SubItems.Add("");
                        byte[] buffer2 = new byte[m_count];
                        Array.Copy(buffer1, buffer2, m_count);
                        string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                        if (fRecvIDPstring.Substring(0, 1) == "A")
                        {
                            int m = fRecvIDPstring.IndexOf('/');
                            Information.mac = fRecvIDPstring.Substring(1, m - 1);
                            Information.portnum = fRecvIDPstring.Substring(m + 1, 4);
                            m = fRecvIDPstring.IndexOf('*');
                            int n = fRecvIDPstring.Length - m - 8;
                            string IDPstring = fRecvIDPstring.Substring(m + 8, n);
                            if (IDPstring != "")
                            {
                                Information.usename = IDPstring.Substring(0, IDPstring.IndexOf('/'));
                                Information.dsname = IDPstring.Substring(IDPstring.IndexOf('/') + 1, IDPstring.Length - IDPstring.IndexOf('/') - 1);
                                Information.IP = ep.ToString().Substring(0, ep.ToString().IndexOf(':'));
                                if (((Information.usename == "") && (Information.dsname == "")) || (Information.dsname == "/"))
                                {
                                    str = "";
                                }
                                else
                                {
                                    str = Information.usename + '/' + Information.dsname;
                                }
                            }
                            else
                            {
                                Information.usename = "";
                                Information.dsname = "";
                                Information.IP = ep.ToString().Substring(0, ep.ToString().IndexOf(':'));
                                str = "";
                            }
                            aListItem.SubItems[1].Text = Information.mac;
                            aListItem.SubItems[2].Text = Information.IP;
                            aListItem.SubItems[3].Text = str;
                        }
                    }
                }
                sock.Close();
            }
            catch (System.Exception ex)
            {
                ex.ToString();
                return;
            }
        }

        private void button23_Click(object sender, EventArgs e)
        {
            Information.IP = "";
            Information.usename = "";
            Information.dsname = "";
            Information.mac = "";
            Information.portnum = "";
            Information.tup = "";
            Information.rm = "";
            Information.cm = "";
            Information.ct = "";
            Information.fc = "";
            Information.dt = "";
            Information.br = "";
            Information.pr = "";
            Information.bb = "";
            Information.rc = "";
            Information.ml = "";
            Information.md = "";
            Information.di = "";
            Information.dp = "";
            Information.gi = "";
            Information.nm = "";
            locateForm loginform = new locateForm();
            DialogResult result = loginform.ShowDialog();
            if (result == DialogResult.OK)
            {
                try
                {
                    string IPAddr = loginform.IP1 + "." + loginform.IP2 + "." + loginform.IP3 + "." + loginform.IP4;
                    listView1.Items.Clear();
                    string str = "";
                    byte[] data = new byte[1024];
                    ListViewItem aListItem = new ListViewItem();
                    Socket sock = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);//ʼһScoketʵϰ,UDP

                    IPEndPoint iep = new IPEndPoint(IPAddress.Broadcast, 65535);//ʼһ͹㲥ָ˿ڵ˿ʵ
                    EndPoint ep = (EndPoint)iep;
                    sock.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);//øscoketʵķʽ
                    string request = "X";//ʼҪ͵
                    byte[] buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    for (int i = 0; i < 3; i++)
                    {
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        iep = new IPEndPoint(IPAddress.Parse(IPAddr), 65535);
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            aListItem = listView1.Items.Add((listView1.Items.Count + 1).ToString());
                            aListItem.SubItems.Add("");
                            aListItem.SubItems.Add("");
                            aListItem.SubItems.Add("");
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('/');
                                Information.mac = fRecvIDPstring.Substring(1, m - 1);
                                Information.portnum = fRecvIDPstring.Substring(m + 1, 4);
                                m = fRecvIDPstring.IndexOf('*');
                                int n = fRecvIDPstring.Length - m - 8;
                                string IDPstring = fRecvIDPstring.Substring(m + 8, n);
                                Information.usename = IDPstring.Substring(0, IDPstring.IndexOf('/'));
                                Information.dsname = IDPstring.Substring(IDPstring.IndexOf('/') + 1, IDPstring.Length - IDPstring.IndexOf('/') - 1);
                                Information.IP = ep.ToString().Substring(0, ep.ToString().IndexOf(':'));
                                if (((Information.usename == "") && (Information.dsname == "")) || (Information.dsname == "/"))
                                {
                                    str = "";
                                }
                                else
                                {
                                    str = Information.usename + '/' + Information.dsname;
                                }
                                if (IPAddr == Information.IP)
                                {
                                    aListItem.SubItems[1].Text = Information.mac;
                                    aListItem.SubItems[2].Text = Information.IP;
                                    aListItem.SubItems[3].Text = str;
                                }
                            }
                            break;
                        }

                    }
                    sock.Close();
                }
                catch (System.Exception ex)
                {
                    ex.ToString();
                }
            }
            loginform.Dispose();
        }

        private void button24_Click(object sender, EventArgs e)
        {
            int i = 0;
            string IPaddr = "";
            try
            {
                if (listView1.SelectedIndices.Count > 0
                    && listView1.SelectedIndices[0] != -1)
                {
                    IPaddr = listView1.SelectedItems[0].SubItems[2].Text;
                    Socket sock = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);//ʼһScoketʵϰ,UDP
                    IPEndPoint iep = new IPEndPoint(IPAddress.Parse(IPaddr), 65535);//ʼһ͹㲥ָ˿ڵ˿ʵ
                    EndPoint ep = (EndPoint)iep;
                    sock.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);//øscoketʵķʽ
                    string request = "X";//ʼҪ͵
                    byte[] buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {

                        sock.SendTo(buffer, iep);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('/');
                                Information.mac = fRecvIDPstring.Substring(1, m - 1);
                                Information.portnum = fRecvIDPstring.Substring(m + 1, 4);
                                m = fRecvIDPstring.IndexOf('*');
                                int n = fRecvIDPstring.Length - m - 8;
                                string IDPstring = fRecvIDPstring.Substring(m + 8, n);
                                Information.usename = IDPstring.Substring(0, IDPstring.IndexOf('/'));
                                Information.dsname = IDPstring.Substring(IDPstring.IndexOf('/') + 1, IDPstring.Length - IDPstring.IndexOf('/') - 1);
                                Information.IP = ep.ToString().Substring(0, ep.ToString().IndexOf(':'));
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "W" + Information.mac;//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(100);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "L";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(50);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GON|1";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "1")
                                {
                                    Information.usename = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GDN|2";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "2")
                                {
                                    Information.dsname = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GFE|3";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "3")
                                {
                                    Information.mac = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GIP|4";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "4")
                                {
                                    Information.IP = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GPN|5";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "5")
                                {
                                    Information.portnum = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GTP|6";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "6")
                                {
                                    Information.tup = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GRM|7";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "7")
                                {
                                    Information.rm = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GCM|8";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "8")
                                {
                                    Information.cm = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GCT|9";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "9")
                                {
                                    Information.ct = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GFC|10";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "10")
                                {
                                    Information.fc = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GDT|11";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "11")
                                {
                                    Information.dt = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GBR|12";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "12")
                                {
                                    Information.br = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GPR|13";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "13")
                                {
                                    Information.pr = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GBB|14";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "14")
                                {
                                    Information.bb = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GRC|15";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "15")
                                {
                                    Information.rc = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GML|16";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "16")
                                {
                                    Information.ml = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GMD|17";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "17")
                                {
                                    Information.md = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GDI|18";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "18")
                                {
                                    Information.di = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GDP|19";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "19")
                                {
                                    Information.dp = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GGI|20";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "20")
                                {
                                    Information.gi = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GNM|21";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "21")
                                {
                                    Information.nm = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    if ((Information.nm == "") || (Information.mac == "") || (Information.IP == "") || (Information.portnum == "") ||
                        (Information.br == "") || (Information.bb == "") || (Information.dt == "") || (Information.rm == "") ||
                        (Information.tup == "") || (Information.pr == "") || (Information.fc == "") || (Information.di == "") || (Information.dp == "") || (Information.gi == ""))
                    {
                        MessageBox.Show("ȷ豸͵״̬!", "ʾ");
                        return;
                    }
                    fSetdlg fsetdlg = new fSetdlg();
                    fsetdlg._IP(Information.IP);
                    fsetdlg._bb(Information.bb);
                    fsetdlg._br(Information.br);
                    fsetdlg._di(Information.di);
                    fsetdlg._dp(Information.dp);
                    fsetdlg._dsname(Information.dsname);
                    fsetdlg._dt(Information.dt);
                    fsetdlg._fc(Information.fc);
                    fsetdlg._gi(Information.gi);
                    fsetdlg._MAC(Information.mac);
                    fsetdlg._nm(Information.nm);
                    fsetdlg._portnum(Information.portnum);
                    fsetdlg._pr(Information.pr);
                    fsetdlg._rm(Information.rm);
                    fsetdlg._tup(Information.tup);
                    fsetdlg._usename(Information.usename);
                    DialogResult result = fsetdlg.ShowDialog();
                    if (result == DialogResult.OK)
                    {
                        request = "L";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(50);

                        request = "SON" + Information.usename + "|18";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDN" + Information.dsname + "|19";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "STP" + Information.tup + "|20";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SPN" + Information.portnum + "|21";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SRM" + Information.rm + "|22";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SFC" + Information.fc + "|23";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDT" + Information.dt + "|24";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SBR" + Information.br + "|25";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SPR" + Information.pr + "|26";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SBB" + Information.bb + "|27";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SRC" + Information.rc + "|28";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SCM" + Information.cm + "|29";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SCT" + Information.ct + "|30";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SML" + Information.ml + "|31";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SMD" + Information.md + "|32";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDI" + Information.di + "|33";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDP" + Information.dp + "|34";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SGI" + Information.gi + "|35";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SNM" + Information.nm + "|36";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SIP" + Information.IP + "|37";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "E";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(500);

                        iep = new IPEndPoint(IPAddress.Broadcast, 65535);//ʼһ͹㲥ָ˿ڵ˿ʵ
                        sock.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);

                        request = "W" + Information.mac;//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(100);

                        request = "L";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(50);

                        request = "SON" + Information.usename + "|18";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDN" + Information.dsname + "|19";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "STP" + Information.tup + "|20";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SPN" + Information.portnum + "|21";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SRM" + Information.rm + "|22";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SFC" + Information.fc + "|23";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDT" + Information.dt + "|24";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SBR" + Information.br + "|25";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SPR" + Information.pr + "|26";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SBB" + Information.bb + "|27";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SRC" + Information.rc + "|28";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SCM" + Information.cm + "|29";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SCT" + Information.ct + "|30";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SML" + Information.ml + "|31";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SMD" + Information.md + "|32";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDI" + Information.di + "|33";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDP" + Information.dp + "|34";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SGI" + Information.gi + "|35";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SNM" + Information.nm + "|36";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SIP" + Information.IP + "|33";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "E";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        listView1.Items.Clear();
                    }
                    fsetdlg.Dispose();
                    sock.Close();
                }
                else
                {
                    MessageBox.Show("ûѡ豸!", "ʾ");
                }
            }
            catch (Exception ex)
            {
                ex.ToString();
            }
        }

        private void button25_Click(object sender, EventArgs e)
        {
            string IPAddr = "";
            ChangeIPdlg changeIPdlg = new ChangeIPdlg();
            DialogResult result = changeIPdlg.ShowDialog();
            if (result == DialogResult.OK)
            {
                IPAddr = changeIPdlg.IP1 + "." + changeIPdlg.IP2 + "." + changeIPdlg.IP3 + "." + changeIPdlg.IP4;
            }
            else
            {
                return;
            }
            try
            {
                if (listView1.SelectedIndices.Count > 0
                    && listView1.SelectedIndices[0] != -1)
                {
                    Information.IP = listView1.SelectedItems[0].SubItems[2].Text;
                    Information.mac = listView1.SelectedItems[0].SubItems[1].Text;
                    Socket sock = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);//ʼһScoketʵϰ,UDP
                    IPEndPoint iep = new IPEndPoint(IPAddress.Parse(Information.IP), 65535);//ʼһ͹㲥ָ˿ڵ˿ʵ
                    EndPoint ep = (EndPoint)iep;
                    //   sock.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);//øscoketʵķʽ
                    string request = "X";//ʼҪ͵
                    byte[] buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    Thread.Sleep(100);

                    request = "L";
                    buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    Thread.Sleep(50);

                    request = "SIP" + IPAddr + "|34";
                    buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    Thread.Sleep(10);

                    request = "E|35";
                    buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    Thread.Sleep(200);

                    iep = new IPEndPoint(IPAddress.Broadcast, 65535);//ʼһ͹㲥ָ˿ڵ˿ʵ
                    sock.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);
                    request = "W" + Information.mac;
                    buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    Thread.Sleep(100);

                    request = "L";
                    buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    Thread.Sleep(50);

                    request = "SIP" + IPAddr + "|34";
                    buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    Thread.Sleep(100);

                    request = "E|35";
                    buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    sock.Close();
                    listView1.Items.Clear();
                }
                else
                {
                    MessageBox.Show("ûѡ豸!", "ʾ");
                }

            }
            catch (Exception ex)
            {
                ex.ToString();
            }
            changeIPdlg.Dispose();
        }

        private void button26_Click(object sender, EventArgs e)
        {
            int i = 0;
            try
            {
                if (listView1.SelectedIndices.Count > 0
                    && listView1.SelectedIndices[0] != -1)
                {
                    Information.IP = listView1.SelectedItems[0].SubItems[2].Text;
                    Socket sock = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);//ʼһScoketʵϰ,UDP

                    IPEndPoint iep = new IPEndPoint(IPAddress.Parse(Information.IP), 65535);//ʼһ͹㲥ָ˿ڵ˿ʵ
                    EndPoint ep = (EndPoint)iep;
                    sock.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);//øscoketʵķʽ
                    string request = "B";//ʼҪ͵
                    byte[] buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            i = 3;
                            sock.Close();
                            break;
                        }
                        i = i + 1;
                    }
                }
                else
                {
                    MessageBox.Show("ûѡ豸!", "ʾ");
                }
            }
            catch (Exception ex)
            {
                ex.ToString();
            }
        }

        private void OpenNetPort_Click(object sender, EventArgs e)
        {
            int port, openresult = 0;
            string IPAddr;
            if (textBox9.Text == "")
                textBox9.Text = "FF";
            readerAddr = Convert.ToByte(textBox9.Text, 16); // $FF;
            if ((textBox7.Text == "") || (textBox8.Text == ""))
                MessageBox.Show("豸IPַ˿!", "ʾ");
            port = Convert.ToInt32(textBox7.Text);
            IPAddr = textBox8.Text;
            ClearReaderInformation();
            openresult = StaticClassReaderA.OpenNetPort(port, IPAddr, ref readerAddr, ref portIndex);
            fOpenComIndex = portIndex;
            if (openresult == 0)
            {
                btnGetReaderInfo_Click(null, null);
            }
            if ((openresult == 0x35) || (openresult == 0x30))
            {
                MessageBox.Show("ͨѶ", "Ϣ");
                StaticClassReaderA.CloseNetPort(portIndex);
                return;
            }
            if ((fOpenComIndex != -1) && (openresult != 0X35) && (openresult != 0X30))
            {
                gbpsetbaud.Enabled = true;
                gbpebpsetting.Enabled = true;
                groupBox9.Enabled = true;
                groupBox16.Enabled = true;
                gbpacc.Enabled = true;

            }

        }

        private void CloseNetPort_Click(object sender, EventArgs e)
        {
            if (fOpenComIndex > 1023)
            {
                fCmdRet = StaticClassReaderA.CloseNetPort(portIndex);
                if (fCmdRet == 0)
                {
                    fOpenComIndex = -1;
                    portIndex = -1;
                    Label_Alarm.Visible = false;
                    InitializeBtnEnable();
                    foreach (Control ctl in this.Controls[1].Controls)      //ҵtabControlؼ,Controls[1]
                        if (ctl is TabPage)                                 //tabControlؼеtabPage
                            foreach (Control ctl1 in ctl.Controls)
                                if (ctl1 is GroupBox)                               //tabPageеGroupBox
                                    foreach (System.Windows.Forms.Control ctl2 in ctl1.Controls)
                                    {
                                        if ((ctl2 is TextBox) && (ctl2.Name != "tbReaderAddr"))   //GroupBoxеTextBox
                                            (ctl2 as TextBox).Text = "";
                                    }

                    lbUIDList.Items.Clear();
                    cbUIDListforInfo.Items.Clear();
                    cbUserUidList.Items.Clear();
                }
            }       
        }

        private void tabControl2_SelectedIndexChanged(object sender, EventArgs e)
        {
            if ((fOpenComIndex > 0) && (fOpenComIndex < 256))
            {
                btnCloseComPort_Click(null, null);
            }
            else if (fOpenComIndex > 1023)
            {
                CloseNetPort_Click(null, null);
            }
        }

    }

}